/*
FILE:Player.h
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#ifndef PLAYER_H
#define PLAYER_H

#include "stdafx.h"
#include "sme.h"


#ifdef __cplusplus
extern "C" {
#endif

SME_BEGIN_STATE_DECLARE(Player)
	/*{{SME_STATE_DECLARE(Player)*/
	SME_STATE_DECLARE(Player)
	SME_STATE_DECLARE(PowerDown)
	SME_STATE_DECLARE(PowerUp)
	SME_STATE_DECLARE(Playing)
	SME_STATE_DECLARE(Pause)
	SME_MAX_STATE(Player)
	/*}}SME_STATE_DECLARE*/
SME_END_STATE_DECLARE

/*{{SME_BEGIN_EVENT_HANDLER(Player)*/
int PlayerEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PlayerExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PowerDownEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PowerDownExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PowerUpEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PowerUpExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PlayingEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PlayingExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PauseEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int PauseExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int OnPowerDownEXT_EVENT_ID_POWER(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int OnPlayingEXT_EVENT_ID_PAUSE_RESUME(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int OnPauseEXT_EVENT_ID_PAUSE_RESUME(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
int OnPowerUpEXT_EVENT_ID_POWER(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent);
/*}}SME_END_EVENT_HANDLER*/



#ifdef __cplusplus
}
#endif

#endif

