/*
FILE: PowerUpDown.c
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#include "sme_debug.h"
#include "PowerUpDown.h"
#include "Service.h"
#include "display.h"
#include "global.h"

SME_BEGIN_STATE_DEF(PowerUpDown,PowerUpDown)
	/*{{SME_STATE_DEF(PowerUpDown,PowerUpDown)*/
	SME_STATE_ENTRY_FUNC(PowerUpDownEntry)
	SME_STATE_EXIT_FUNC(PowerUpDownExit)
	SME_ON_EVENT(EVENT_KEY_LEFTSOFT,OnPowerUpDownEVENT_KEY_LEFTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_RIGHTSOFT,OnPowerUpDownEVENT_KEY_RIGHTSOFT,SME_INTERNAL_TRAN)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,PowerDown)
	/*{{SME_STATE_DEF(PowerUpDown,PowerDown)*/
	SME_STATE_ENTRY_FUNC(PowerDownEntry)
	SME_STATE_EXIT_FUNC(PowerDownExit)
	SME_ON_EVENT(EVENT_POWER_UP,NULL,PowerUp)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,PowerUp)
	/*{{SME_STATE_DEF(PowerUpDown,PowerUp)*/
	SME_STATE_ENTRY_FUNC(PowerUpEntry)
	SME_STATE_EXIT_FUNC(PowerUpExit)
	SME_ON_EVENT(EVENT_KEY_POWER,NULL,PowerDown)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,Idle)
	/*{{SME_STATE_DEF(PowerUpDown,Idle)*/
	SME_STATE_ENTRY_FUNC(IdleEntry)
	SME_STATE_EXIT_FUNC(IdleExit)
	SME_ON_EVENT(EVENT_OPEN_MENU_MAIN,OnIdleEVENT_OPEN_MENU_MAIN,ImageSurf)
	SME_ON_EVENT(EVENT_KEY_0,OnIdleEVENT_KEY_0,DigitInput)
	SME_ON_EVENT(EVENT_KEY_1,OnIdleEVENT_KEY_1,DigitInput)
	SME_ON_EVENT(EVENT_KEY_2,OnIdleEVENT_KEY_2,DigitInput)
	SME_ON_EVENT(EVENT_KEY_3,OnIdleEVENT_KEY_3,DigitInput)
	SME_ON_EVENT(EVENT_KEY_4,OnIdleEVENT_KEY_4,DigitInput)
	SME_ON_EVENT(EVENT_KEY_5,OnIdleEVENT_KEY_5,DigitInput)
	SME_ON_EVENT(EVENT_KEY_6,OnIdleEVENT_KEY_6,DigitInput)
	SME_ON_EVENT(EVENT_KEY_7,OnIdleEVENT_KEY_7,DigitInput)
	SME_ON_EVENT(EVENT_KEY_8,OnIdleEVENT_KEY_8,DigitInput)
	SME_ON_EVENT(EVENT_KEY_9,OnIdleEVENT_KEY_9,DigitInput)
	SME_ON_EVENT(EVENT_ON_TIMER,OnIdleEVENT_ON_TIMER,SME_INTERNAL_TRAN)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,MenuSurf)
	/*{{SME_STATE_DEF(PowerUpDown,MenuSurf)*/
	SME_STATE_ENTRY_FUNC(MenuSurfEntry)
	SME_STATE_EXIT_FUNC(MenuSurfExit)
	SME_ON_EVENT(EVENT_MENU_EXIT,NULL,Idle)
	SME_ON_EVENT(EVENT_MENU_SEL,OnMenuSurfEVENT_MENU_SEL,Function)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,Function)
	/*{{SME_STATE_DEF(PowerUpDown,Function)*/
	SME_STATE_ENTRY_FUNC(FunctionEntry)
	SME_STATE_EXIT_FUNC(FunctionExit)
	SME_ON_EVENT(EVENT_DLG_OK,OnFunctionEVENT_DLG_OK,Idle)
	SME_ON_EVENT(EVENT_DLG_CANCEL,NULL,Idle)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,DigitInput)
	/*{{SME_STATE_DEF(PowerUpDown,DigitInput)*/
	SME_STATE_ENTRY_FUNC(DigitInputEntry)
	SME_STATE_EXIT_FUNC(DigitInputExit)
	SME_ON_EVENT(EVENT_EDIT_OK,OnDigitInputEVENT_EDIT_OK,Function)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

SME_BEGIN_STATE_DEF(PowerUpDown,ImageSurf)
	/*{{SME_STATE_DEF(PowerUpDown,ImageSurf)*/
	SME_STATE_ENTRY_FUNC(ImageSurfEntry)
	SME_STATE_EXIT_FUNC(ImageSurfExit)
	SME_ON_EVENT(EVENT_IMAGE_EXIT,NULL,Idle)
	SME_ON_EVENT(EVENT_IMAGE_FUNC,OnImageSurfEVENT_IMAGE_FUNC,Function)
	SME_ON_EVENT(EVENT_IMAGE_OPEN,OnImageSurfEVENT_IMAGE_OPEN,MenuSurf)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

/*{{SME_STATE_STATETREE_SEPARATOR}}*/

SME_BEGIN_STATE_TREE_DEF(PowerUpDown)
	/*{{SME_STATE_TREE_DEF(PowerUpDown)*/
	SME_STATE(PowerUpDown,PowerUpDown,SME_INVALID_STATE,PowerDown)
	SME_STATE(PowerUpDown,PowerDown,0,-1)
	SME_STATE(PowerUpDown,PowerUp,0,Idle)
	SME_STATE(PowerUpDown,Idle,PowerUp,-1)
	SME_STATE(PowerUpDown,MenuSurf,PowerUp,-1)
	SME_STATE(PowerUpDown,Function,PowerUp,-1)
	SME_STATE(PowerUpDown,DigitInput,PowerUp,-1)
	SME_STATE(PowerUpDown,ImageSurf,PowerUp,-1)
	/*}}SME_STATE_TREE_DEF*/
SME_END_STATE_TREE_DEF

/*{{SME_DEC_IMP_SEPARATOR}}*/

SME_APPLICATION_DEF(PowerUpDown, "PowerUpDown")

void* pBlockForPower=NULL;
DISPLAY_BUFFER Data;
BOOL isCalling;
unsigned int m_nTimer = 0;
extern SME_THREAD_CONTEXT_PT g_pAppChildThreadContext;


int PowerUpDownEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	pBlockForPower=SmeMAlloc(32);
	default_lang=0;
	default_font=0;
	return 0;
}

int PowerUpDownExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeMFree(pBlockForPower);
	return 0;
}

int PowerUpEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	m_nTimer = SrvSetTimer(1000,pApp->pPortInfo);
	return 0;
}

int PowerUpExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	if (m_nTimer!=0)
	{
		SrvKillTimer(m_nTimer);
		m_nTimer = 0;
	};
	return 0;
}

int PowerDownEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SrvPowerControl();
	return 0;
}

int PowerDownExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int IdleEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SoftKey.isDefined=FALSE;
	SelFunc.isSelected=FALSE;
	SelMenu.isSelected=FALSE;

	isCalling=FALSE;
	
	ClearScreen();
	SrvClearDisplay();

	DrawBitmap(0,0,IDB_BG);
	SnapShot(Data);
	UpdateClock();
	UICtrlSetSoftkey(&SoftKey,SID_IDLE_SKL,EVENT_OPEN_MENU_LANG,SID_IDLE_SKR,EVENT_OPEN_MENU_MAIN);
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	
	SrvUpdateDisplay(0,0,96,64,Buf);
	
	return 0;
}

int OnIdleEVENT_ON_TIMER(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UpdateClock();
	return 0;
}

int IdleExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int UpdateClock(){

	int hour,minute,second;

	SetRectangle(15,20,64,13,Data);
	SrvGetTime((int*)&hour,(int*)&minute,(int*)&second);
	DrawNumber(15,20,hour,0);
	DrawFontBitmap(31,20,0,':',0);
	DrawNumber(39,20,minute,0);
	DrawFontBitmap(55,20,0,':',0);
	DrawNumber(63,20,second,0);
	
	SrvRefreshDisplay(15,20,64,13,Buf);

	return 0;
}

int MenuSurfEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeActivateApp(&SME_GET_APP_VAR(MenuCtrl),&SME_GET_APP_VAR(PowerUpDown));
	
	return 0;
}

int MenuSurfExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeDeactivateApp(&SME_GET_APP_VAR(MenuCtrl));
	return 0;
}

int ImageSurfEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeActivateApp(&SME_GET_APP_VAR(ImageList),&SME_GET_APP_VAR(PowerUpDown));
	return 0;
}

int ImageSurfExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeDeactivateApp(&SME_GET_APP_VAR(ImageList));
	return 0;
}

int FunctionEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeActivateApp(&SME_GET_APP_VAR(DialogCtrl),&SME_GET_APP_VAR(PowerUpDown));
	if(isCalling)
		UICtrlPostInternalEvent(EVENT_ON_CALLING,NULL);

	// Post an event to another thread
	// Playing media
	SmePostExtThreadEvent(EVENT_PLAY_START, NULL, 0, NULL, g_pAppChildThreadContext);

	return 0;
}

int FunctionExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeDeactivateApp(&SME_GET_APP_VAR(DialogCtrl));

	// Post an event to another thread
	// Stop playing
	SmePostExtThreadEvent(EVENT_PLAY_STOP, NULL, 0, NULL, g_pAppChildThreadContext);
	return 0;
}

int OnPowerUpDownEVENT_KEY_LEFTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlLeftSoftKeyPress(&SoftKey);
	return 0;
}

int OnPowerUpDownEVENT_KEY_RIGHTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlRightSoftKeyPress(&SoftKey);
	return 0;
}

int OnIdleEVENT_OPEN_MENU_MAIN(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	default_imagemenu=IDR_MENU_MAIN_0;
	return 0;
}

int OnMenuSurfEVENT_MENU_SEL (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SelMenu.isSelected=TRUE;
	SelMenu.menuId=pEvent->Data.Int.nParam1;
	return 0;
}

int OnImageSurfEVENT_IMAGE_OPEN(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	default_topmenu=pEvent->Data.Int.nParam1;
	return 0;
}

int OnImageSurfEVENT_IMAGE_FUNC(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SelMenu.isSelected=TRUE;
	SelMenu.menuId=pEvent->Data.Int.nParam1;
	return 0;
}

int OnFunctionEVENT_DLG_OK (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}

int DigitInputEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeActivateApp(&SME_GET_APP_VAR(EditCtrl),&SME_GET_APP_VAR(PowerUpDown));
	return 0;
}

int DigitInputExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeDeactivateApp(&SME_GET_APP_VAR(EditCtrl));
	return 0;
}

int OnIdleEVENT_KEY_0 (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='0';
	return 0;
}

int OnIdleEVENT_KEY_1(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='1';
	return 0;
}

int OnIdleEVENT_KEY_2(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='2';
	return 0;
}

int OnIdleEVENT_KEY_3(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='3';
	return 0;
}

int OnIdleEVENT_KEY_4(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
    Digit_Input='4';
	return 0;
}


int OnIdleEVENT_KEY_5(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='5';
	return 0;
}

int OnIdleEVENT_KEY_6(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='6';
	return 0;
}

int OnIdleEVENT_KEY_7(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='7';
	return 0;
}

int OnIdleEVENT_KEY_8(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='8';
	return 0;
}

int OnIdleEVENT_KEY_9(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	Digit_Input='9';
	return 0;
}

int OnDigitInputEVENT_EDIT_OK (struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	isCalling=TRUE;
	return 0;
}

