#ifndef SME_RC_H
#define SME_RC_H

#include "sme.h"

#ifdef __cplusplus
extern "C" {
#endif


#define SME_MAX_LANGUAGE_NUM              8

#define  SID_TITLE                        0    
#define  SID_IDLE_SKL                     1    
#define  SID_IDLE_SKR                     2    
#define  SID_MENU_SKL                     3    
#define  SID_MENU_SKR                     4    
#define  SID_DLG_SKL                      5    
#define  SID_DLG_SKR                      6    
#define  SID_EDIT_DEL                     7    
#define  SID_EDIT_OK                      8    
#define  SID_IMAGE_SKL                    9    
#define  SID_IMAGE_SKR                    10   
#define  SID_WARNING                      11   
#define  SID_WARN_SKL                     12   
#define  SID_WARN_SKR                     13   
#define  SID_ON_CALLING                   14   
#define  IDR_MENU_MAIN_SID_0              15   
#define  IDR_MENU_MAIN_SID_1              16   
#define  ID_MENU_SMS_NEW                  17   
#define  ID_MENU_SMS_READ                 18   
#define  ID_MENU_SMS_SAVE                 19   
#define  ID_MENU_SMS_FIND                 20   
#define  ID_MENU_SMS_DEL                  21   
#define  ID_MENU_CONTACT                  22   
#define  IDR_MENU_MAIN_SID_2              23   
#define  IDR_MENU_MAIN_SID_3              24   
#define  ID_MENU_SERVICE_SUB              25   
#define  ID_MENU_SERVICE_CANCEL           26   
#define  IDR_MENU_MAIN_SID_4              27   
#define  IDR_MENU_MAIN_SID_5              28   
#define  ID_MENU_NEWS_ENT                 29   
#define  ID_MENU_NEWS_SOCIAL              30   
#define  ID_MENU_NEWS_SPORTS              31   
#define  ID_MENU_NETWORK_FRIEND_WEATHER   32   
#define  ID_MENU_NETWORK_MANAGE           33   
#define  IDR_MENU_MAIN_SID_6              34   
#define  ID_MENU_TOOL_GAME                35   
#define  ID_MENU_TOOL_CLOCK               36   
#define  ID_MENU_TOOL_NOTE                37   
#define  ID_MENU_EXIT                     38   
#define  IDR_MENU_MAIN_1                  0    
#define  IDR_MENU_MAIN_3                  1    
#define  IDR_MENU_MAIN_5                  2    
#define  IDR_MENU_MAIN_4                  3    
#define  IDR_MENU_MAIN_2                  4    
#define  IDR_MENU_MAIN_6                  5    
#define  IDR_MENU_MAIN_0                  6    
#define  IDR_MENU_MAIN                    7    
#define  IDB_ROLL                         0    
#define  IDB_CONTACT                      1    
#define  IDB_SMS                          2    
#define  IDB_NETWORK                      3    
#define  IDB_EXIT                         4    
#define  IDB_TOOL                         5    
#define  IDB_BG                           6    


#define  TEXT_STR_INDEX_NUM               39   
#define  MENU_INDEX_NUM                   8    
#define  BITMAP_INDEX_NUM                 7    
#define  FONT_INDEX_NUM                   1    
#define  TEXT_STRING_TOTAL_SIZE           292  
#define  MENU_DATA_NUM                    24   
#define  BITMAP_DATA_TOTAL_SIZE           7872 
#define  FONT_DATA_TOTAL_SIZE             2912 

#define  SME_LANGUAGE_NUM                 1    

enum {
	SME_RC_TYPE_TEXT_STR,
	SME_RC_TYPE_MENU,
	SME_RC_TYPE_BITMAP
};

typedef struct SME_RESOURCE_HEADER_T {
	char sIdentifier[32];
	unsigned long nVersion;
	unsigned long nLangNum;
} SME_RESOURCE_HEADER_T;

typedef unsigned long SME_TEXT_STR_IDX_T;

typedef struct SME_MENU_IDX_T {
	unsigned short nRcType;
	unsigned short nItemNum;
	unsigned long nOffset;
} SME_MENU_IDX_T;

typedef struct SME_MENU_DATA_T {
	unsigned long nMenuTitleID;
	long nSubMenuID;
} SME_MENU_DATA_T;

typedef struct SME_BITMAP_IDX_T {
	unsigned short nWidth;
	unsigned short nHeight;
	unsigned short nBitCountPerPixel;
	unsigned short nLength;
	unsigned long nOffset;
} SME_BITMAP_IDX_T;

typedef struct SME_FONT_IDX_T {
	unsigned short nWidth;
	unsigned short nHeight;
	unsigned short nStartChar;
	unsigned short nEndChar;
	unsigned long nLength;
	unsigned long nOffset;
} SME_FONT_IDX_T;

typedef struct SME_BITMAP_DATA_T {
	unsigned short nWidth;
	unsigned short nHeight;
	unsigned short nBitCountPerPixel;
	const unsigned char *pData;
	unsigned long nLength;
} SME_BITMAP_DATA_T;

typedef struct SME_FONT_INFO_T {
	unsigned short nWidth;
	unsigned short nHeight;
	unsigned short nStartChar;
	unsigned short nEndChar;
	const unsigned char *pData;
	unsigned long nLength;
} SME_FONT_INFO_T;

BOOL SmeGetTextString(unsigned long nRcId, unsigned char nLang, const SME_CHAR** pText);
BOOL SmeGetMenuData(unsigned long nRcId, unsigned short *pItemNum, const struct SME_MENU_DATA_T** pMenuData);
BOOL SmeGetBitmap (unsigned long nRcId, struct SME_BITMAP_DATA_T *pBitmapData);
BOOL SmeGetFontInfo (unsigned long nFontID, struct SME_FONT_INFO_T *pFontInfo);
BOOL SmeGetFontBitmap (unsigned long nFontID, unsigned short nChar, const unsigned char** pFontData, unsigned long * pLength);

#ifdef __cplusplus
}
#endif

#endif

