#include "sme_rc.h"

struct SME_SRC_IMAGE_T {
	struct SME_RESOURCE_HEADER_T  SrcHdr;
	unsigned long TextIdxTbl[TEXT_STR_INDEX_NUM];
	struct SME_MENU_IDX_T MenuIdxTbl[MENU_INDEX_NUM];
	struct SME_BITMAP_IDX_T BitmapIdxTbl[BITMAP_INDEX_NUM];
	struct SME_FONT_IDX_T FontIdxTbl[FONT_INDEX_NUM];
	SME_CHAR   TextStrData[TEXT_STRING_TOTAL_SIZE];
	SME_MENU_DATA_T MenuData[MENU_DATA_NUM];
	unsigned char   BitmapData[BITMAP_DATA_TOTAL_SIZE];
	unsigned char   FontData[FONT_DATA_TOTAL_SIZE];
};

const struct SME_SRC_IMAGE_T RcDataImage = {
	{{'S','t','a','t','e',' ','M','a','c','h','i','n','e',' ','W','i','z','a','r','d',0}, 1L, 1},
	{/* String index struct */
	 0,  /* Action */
	 8,  /* \n */
	 12,  /* Menu */
	 20,  /* Back */
	 28,  /* Open */
	 36,  /* No */
	 40,  /* Yes */
	 44,  /* Del */
	 48,  /* OK */
	 52,  /* Back */
	 60,  /* Enter */
	 68,  /* Lack Mem */
	 80,  /*  \n  */
	 84,  /* OK */
	 88,  /* Calling */
	 96,  /* MAIN */
	 104,  /* SMS */
	 108,  /* Write */
	 116,  /* Read */
	 124,  /* Save */
	 132,  /* Find */
	 140,  /* Delete */
	 148,  /* CONTACT */
	 156,  /* NETWORK */
	 164,  /* Service */
	 172,  /* Subscribe */
	 184,  /* Cancel */
	 192,  /* Friend */
	 200,  /* News */
	 208,  /* Entertain */
	 220,  /* Social */
	 228,  /* Sports */
	 236,  /* Weather */
	 244,  /* Manage */
	 252,  /* TOOL */
	 260,  /* Game */
	 268,  /* Clock */
	 276,  /* Note */
	 284 /* EXIT */
	},
	{/* Menu index struct */
	 {SME_RC_TYPE_MENU, 5, 0  }, /* IDR_MENU_MAIN_1 */
	 {SME_RC_TYPE_MENU, 2, 5  }, /* IDR_MENU_MAIN_3 */
	 {SME_RC_TYPE_MENU, 3, 7  }, /* IDR_MENU_MAIN_5 */
	 {SME_RC_TYPE_MENU, 2, 10 }, /* IDR_MENU_MAIN_4 */
	 {SME_RC_TYPE_MENU, 3, 12 }, /* IDR_MENU_MAIN_2 */
	 {SME_RC_TYPE_MENU, 3, 15 }, /* IDR_MENU_MAIN_6 */
	 {SME_RC_TYPE_MENU, 5, 18 }, /* IDR_MENU_MAIN_0 */
	 {SME_RC_TYPE_MENU, 1, 23 }  /* IDR_MENU_MAIN */
	},
	{/* Bitmap index struct */
	 {8, 48, 8, 384, 0}, /* IDB_ROLL */
	 {24, 24, 8, 576, 384}, /* IDB_CONTACT */
	 {24, 24, 8, 576, 960}, /* IDB_SMS */
	 {24, 24, 8, 576, 1536}, /* IDB_NETWORK */
	 {24, 24, 8, 576, 2112}, /* IDB_EXIT */
	 {24, 24, 8, 576, 2688}, /* IDB_TOOL */
	 {96, 48, 8, 4608, 3264}  /* IDB_BG */
	},
	{/* Font index Struct */
	 {8, 13, 0x20, 0xFF, 2912, 0}  /* Courier */
	},
	{/* String data Struct */
	 0x41, 0x63, 0x74, 0x69, 0x6F, 0x6E, 0x00, 0x00,  /* "Action" */
	 0x00, 0x00, 0x00, 0x00,  /* "" */
	 0x4D, 0x65, 0x6E, 0x75, 0x00, 0x00, 0x00, 0x00,  /* "Menu" */
	 0x42, 0x61, 0x63, 0x6B, 0x00, 0x00, 0x00, 0x00,  /* "Back" */
	 0x4F, 0x70, 0x65, 0x6E, 0x00, 0x00, 0x00, 0x00,  /* "Open" */
	 0x4E, 0x6F, 0x00, 0x00,  /* "No" */
	 0x59, 0x65, 0x73, 0x00,  /* "Yes" */
	 0x44, 0x65, 0x6C, 0x00,  /* "Del" */
	 0x4F, 0x4B, 0x00, 0x00,  /* "OK" */
	 0x42, 0x61, 0x63, 0x6B, 0x00, 0x00, 0x00, 0x00,  /* "Back" */
	 0x45, 0x6E, 0x74, 0x65, 0x72, 0x00, 0x00, 0x00,  /* "Enter" */
	 0x4C, 0x61, 0x63, 0x6B, 0x20, 0x4D, 0x65, 0x6D, 0x00, 0x00, 0x00, 0x00,  /* "Lack Mem" */
	 0x20, 0x00, 0x00, 0x00,  /* " " */
	 0x4F, 0x4B, 0x00, 0x00,  /* "OK" */
	 0x43, 0x61, 0x6C, 0x6C, 0x69, 0x6E, 0x67, 0x00,  /* "Calling" */
	 0x4D, 0x41, 0x49, 0x4E, 0x00, 0x00, 0x00, 0x00,  /* "MAIN" */
	 0x53, 0x4D, 0x53, 0x00,  /* "SMS" */
	 0x57, 0x72, 0x69, 0x74, 0x65, 0x00, 0x00, 0x00,  /* "Write" */
	 0x52, 0x65, 0x61, 0x64, 0x00, 0x00, 0x00, 0x00,  /* "Read" */
	 0x53, 0x61, 0x76, 0x65, 0x00, 0x00, 0x00, 0x00,  /* "Save" */
	 0x46, 0x69, 0x6E, 0x64, 0x00, 0x00, 0x00, 0x00,  /* "Find" */
	 0x44, 0x65, 0x6C, 0x65, 0x74, 0x65, 0x00, 0x00,  /* "Delete" */
	 0x43, 0x4F, 0x4E, 0x54, 0x41, 0x43, 0x54, 0x00,  /* "CONTACT" */
	 0x4E, 0x45, 0x54, 0x57, 0x4F, 0x52, 0x4B, 0x00,  /* "NETWORK" */
	 0x53, 0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x00,  /* "Service" */
	 0x53, 0x75, 0x62, 0x73, 0x63, 0x72, 0x69, 0x62, 0x65, 0x00, 0x00, 0x00,  /* "Subscribe" */
	 0x43, 0x61, 0x6E, 0x63, 0x65, 0x6C, 0x00, 0x00,  /* "Cancel" */
	 0x46, 0x72, 0x69, 0x65, 0x6E, 0x64, 0x00, 0x00,  /* "Friend" */
	 0x4E, 0x65, 0x77, 0x73, 0x00, 0x00, 0x00, 0x00,  /* "News" */
	 0x45, 0x6E, 0x74, 0x65, 0x72, 0x74, 0x61, 0x69, 0x6E, 0x00, 0x00, 0x00,  /* "Entertain" */
	 0x53, 0x6F, 0x63, 0x69, 0x61, 0x6C, 0x00, 0x00,  /* "Social" */
	 0x53, 0x70, 0x6F, 0x72, 0x74, 0x73, 0x00, 0x00,  /* "Sports" */
	 0x57, 0x65, 0x61, 0x74, 0x68, 0x65, 0x72, 0x00,  /* "Weather" */
	 0x4D, 0x61, 0x6E, 0x61, 0x67, 0x65, 0x00, 0x00,  /* "Manage" */
	 0x54, 0x4F, 0x4F, 0x4C, 0x00, 0x00, 0x00, 0x00,  /* "TOOL" */
	 0x47, 0x61, 0x6D, 0x65, 0x00, 0x00, 0x00, 0x00,  /* "Game" */
	 0x43, 0x6C, 0x6F, 0x63, 0x6B, 0x00, 0x00, 0x00,  /* "Clock" */
	 0x4E, 0x6F, 0x74, 0x65, 0x00, 0x00, 0x00, 0x00,  /* "Note" */
	 0x45, 0x58, 0x49, 0x54, 0x00, 0x00, 0x00, 0x00 /* "EXIT" */
	},
	{/* Menu data struct */
	 {ID_MENU_SMS_NEW, -1}, /* Write */
	 {ID_MENU_SMS_READ, -1}, /* Read */
	 {ID_MENU_SMS_SAVE, -1}, /* Save */
	 {ID_MENU_SMS_FIND, -1}, /* Find */
	 {ID_MENU_SMS_DEL, -1}, /* Delete */
	 {ID_MENU_SERVICE_SUB, -1}, /* Subscribe */
	 {ID_MENU_SERVICE_CANCEL, -1}, /* Cancel */
	 {ID_MENU_NEWS_ENT, -1}, /* Entertain */
	 {ID_MENU_NEWS_SOCIAL, -1}, /* Social */
	 {ID_MENU_NEWS_SPORTS, -1}, /* Sports */
	 {IDR_MENU_MAIN_SID_5, IDR_MENU_MAIN_5}, /* News */
	 {ID_MENU_NETWORK_FRIEND_WEATHER, -1}, /* Weather */
	 {IDR_MENU_MAIN_SID_3, IDR_MENU_MAIN_3}, /* Service */
	 {IDR_MENU_MAIN_SID_4, IDR_MENU_MAIN_4}, /* Friend */
	 {ID_MENU_NETWORK_MANAGE, -1}, /* Manage */
	 {ID_MENU_TOOL_GAME, -1}, /* Game */
	 {ID_MENU_TOOL_CLOCK, -1}, /* Clock */
	 {ID_MENU_TOOL_NOTE, -1}, /* Note */
	 {IDR_MENU_MAIN_SID_1, IDR_MENU_MAIN_1}, /* SMS */
	 {ID_MENU_CONTACT, -1}, /* CONTACT */
	 {IDR_MENU_MAIN_SID_2, IDR_MENU_MAIN_2}, /* NETWORK */
	 {IDR_MENU_MAIN_SID_6, IDR_MENU_MAIN_6}, /* TOOL */
	 {ID_MENU_EXIT, -1}, /* EXIT */
	 {IDR_MENU_MAIN_SID_0, IDR_MENU_MAIN_0} /* MAIN */
	},
	{/* Bitmap data struct */
	 /* IDB_ROLL */ 
	 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFF, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC,  
	 0xFF, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF,  
	 0xFC, 0xFC, 0xFC, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,  
	 0xFC, 0xFF, 0xFF, 0xFF,  
	 /* IDB_CONTACT */ 
	 0xD6, 0xC7, 0x86, 0xC6, 0x97, 0x97, 0xC6, 0xC7, 0x96, 0x9F,  
	 0xD7, 0x9F, 0xDE, 0xAF, 0xDE, 0xAE, 0xDE, 0xEE, 0x9E, 0xEF,  
	 0xAE, 0x86, 0x97, 0x96, 0xD6, 0x86, 0xC7, 0xC6, 0xC6, 0xC6,  
	 0xC6, 0xC7, 0x9E, 0x9E, 0xDE, 0xD6, 0xDE, 0xD7, 0xDE, 0xDF,  
	 0xAF, 0xEE, 0xDF, 0x86, 0x96, 0x9E, 0x96, 0x96, 0xC6, 0xC6,  
	 0xC7, 0xC6, 0xC7, 0xC6, 0x87, 0x87, 0x9E, 0xAF, 0xB6, 0xAF,  
	 0x9F, 0xDE, 0x9E, 0xDE, 0xDF, 0xDE, 0xEE, 0x97, 0x96, 0x96,  
	 0x86, 0x87, 0x87, 0xC7, 0xC6, 0x86, 0xC7, 0xC6, 0x9E, 0xAE,  
	 0xDE, 0xEE, 0x9F, 0xDE, 0xDE, 0xD6, 0xDF, 0xDE, 0xDE, 0xDE,  
	 0x97, 0xEE, 0x9E, 0xD6, 0x97, 0x86, 0xC6, 0xC6, 0x86, 0xC7,  
	 0xC6, 0x97, 0xDE, 0xDF, 0xAF, 0xDE, 0xD6, 0xD6, 0xD7, 0x97,  
	 0x9E, 0x97, 0x9F, 0x9F, 0x9E, 0xAF, 0x9E, 0x87, 0x96, 0x96,  
	 0xD6, 0xC7, 0xC7, 0xC6, 0xC7, 0x96, 0xEE, 0xDE, 0xDE, 0xDF,  
	 0x9E, 0xD7, 0x96, 0x86, 0x96, 0x96, 0x86, 0x9E, 0x9E, 0x9E,  
	 0xDF, 0x96, 0xD6, 0xDF, 0x87, 0xC6, 0x86, 0xC6, 0x86, 0x97,  
	 0xEF, 0xD7, 0xDE, 0xAE, 0xEE, 0x97, 0x86, 0x87, 0x97, 0x9E,  
	 0x9F, 0x96, 0x56, 0x9F, 0x9E, 0xD6, 0xEF, 0xEE, 0xC6, 0x86,  
	 0xC7, 0xC7, 0xC7, 0x86, 0xAE, 0xDE, 0x9F, 0xDE, 0xDF, 0x9E,  
	 0x97, 0x96, 0x87, 0x96, 0x55, 0x45, 0x95, 0xEE, 0xAF, 0xEE,  
	 0xEE, 0xAF, 0x96, 0xC7, 0xC6, 0xC6, 0x86, 0xC6, 0x9F, 0xDE,  
	 0xDF, 0xEE, 0xAF, 0xDE, 0x96, 0x95, 0x85, 0x86, 0x9F, 0x95,  
	 0x45, 0xEF, 0xEE, 0xEF, 0xEE, 0xB6, 0xC7, 0xC6, 0x87, 0xC6,  
	 0x87, 0xC6, 0x87, 0xB6, 0xDE, 0xEE, 0xDE, 0xAF, 0xEE, 0xEF,  
	 0xAE, 0x9F, 0x46, 0x45, 0x43, 0xEF, 0xEE, 0xB7, 0xEE, 0xEF,  
	 0xC6, 0x87, 0xC6, 0xC6, 0xC7, 0xC6, 0xC6, 0x97, 0xEF, 0xEF,  
	 0xEE, 0xEE, 0xEF, 0xAE, 0x9E, 0x96, 0x96, 0x56, 0x45, 0x9E,  
	 0xDE, 0xAF, 0xEF, 0x9D, 0xC6, 0xC7, 0xC7, 0xC6, 0x86, 0xC7,  
	 0xC6, 0x86, 0x9E, 0xAE, 0xEF, 0xAE, 0x07, 0xDF, 0x97, 0x96,  
	 0x87, 0x56, 0x55, 0x9E, 0xD7, 0xEE, 0x45, 0x96, 0xD6, 0xC6,  
	 0x86, 0xC6, 0x86, 0xC6, 0xC7, 0x86, 0x87, 0x96, 0x97, 0x9E,  
	 0xAE, 0xEE, 0x9E, 0x86, 0x16, 0x86, 0x95, 0x96, 0x96, 0x55,  
	 0x9E, 0xEF, 0x97, 0xC6, 0xC7, 0xC7, 0xC7, 0xC7, 0xC6, 0x96,  
	 0x9F, 0xAE, 0xAE, 0x9F, 0x97, 0x86, 0x96, 0x5E, 0x86, 0x86,  
	 0x86, 0x96, 0x9D, 0x9E, 0xEF, 0xEE, 0xC6, 0xC7, 0x86, 0xC6,  
	 0xC6, 0x96, 0x9F, 0x07, 0xEF, 0xEE, 0xEF, 0xEE, 0xEE, 0x9E,  
	 0x56, 0x9D, 0x95, 0x86, 0x86, 0x55, 0x96, 0xDE, 0xEE, 0xEE,  
	 0xD6, 0x87, 0xC6, 0x87, 0x9E, 0xEE, 0xDF, 0xEE, 0x9E, 0xEE,  
	 0xAF, 0xEE, 0xEE, 0x9F, 0x86, 0x96, 0x45, 0x55, 0x95, 0x85,  
	 0x86, 0xEF, 0xEE, 0xAF, 0xC7, 0xC6, 0xC6, 0x97, 0xEE, 0xDF,  
	 0xD6, 0xDE, 0x9F, 0xDF, 0xEE, 0xAE, 0xEF, 0x9F, 0x9E, 0x96,  
	 0x95, 0x85, 0x86, 0x9E, 0x9D, 0x55, 0x9E, 0x9E, 0xD6, 0xC7,  
	 0x96, 0xAE, 0xDE, 0x9E, 0xDE, 0xDF, 0xEE, 0xDE, 0xEE, 0xEF,  
	 0xEE, 0xEE, 0x9E, 0x56, 0x95, 0xAE, 0x9F, 0xEE, 0xAE, 0xEF,  
	 0x9E, 0x96, 0xC6, 0xC7, 0x9E, 0xDF, 0xDF, 0xDF, 0xAE, 0xEE,  
	 0x9F, 0xDF, 0xAE, 0xDE, 0xDF, 0xAF, 0x95, 0x55, 0x9E, 0xEE,  
	 0xEE, 0xAF, 0x07, 0xDE, 0xEE, 0x96, 0x96, 0xC7, 0x9E, 0x9E,  
	 0xDE, 0xEE, 0xDF, 0xDF, 0xDE, 0xDE, 0xDE, 0xEF, 0xAE, 0x96,  
	 0x55, 0x45, 0xAF, 0xDF, 0xEE, 0xEE, 0xDF, 0xDF, 0xDE, 0xAE,  
	 0x97, 0xC6, 0x87, 0xAE, 0xDF, 0xEE, 0xDE, 0xDE, 0xDE, 0xAF,  
	 0x9F, 0x96, 0x96, 0x97, 0x55, 0x86, 0x07, 0xEE, 0xAF, 0xEE,  
	 0x9E, 0xDE, 0x9F, 0x9E, 0xC6, 0xC6, 0xC6, 0x86, 0x9E, 0x9F,  
	 0x9E, 0x97, 0x96, 0x86, 0xC6, 0x87, 0x87, 0x55, 0x45, 0x96,  
	 0x9F, 0xDF, 0xDE, 0xD7, 0xDE, 0xD7, 0xDE, 0x96, 0xC7, 0xC6,  
	 0x87, 0xC7, 0xC6, 0xC7, 0xC6, 0xC6, 0x87, 0xC7, 0xC6, 0xC6,  
	 0x96, 0x95, 0x56, 0x5E, 0x9D, 0xDF, 0xDE, 0xD7, 0xDE, 0x9E,  
	 0xDE, 0x9D, 0x97, 0xC6, 0x87, 0xD6, 0xC6, 0x86, 0xC7, 0xC6,  
	 0xC6, 0x96, 0xC6, 0xC7, 0x96, 0x56, 0x56, 0x95, 0x55, 0x96,  
	 0xD6, 0x9F, 0xDE, 0xD7, 0x96, 0x96,  
	 /* IDB_SMS */ 
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB6,  
	 0x5D, 0x13, 0x6E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB6, 0x55, 0x13, 0x0A, 0x55, 0xB6, 0x07, 0xF6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xAE, 0x55, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x0A, 0x10, 0x00, 0x53, 0xAF,  
	 0x5D, 0x12, 0x9A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x52, 0x13,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0x12, 0x0A,  
	 0x00, 0x0A, 0xB7, 0x5D, 0x92, 0x42, 0x42, 0xEF, 0xFF, 0xFF,  
	 0xF6, 0x93, 0xAD, 0x00, 0x5B, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x07, 0x00, 0x12, 0x13, 0x9D, 0x6E, 0x92, 0x42, 0x90,  
	 0x0A, 0xFF, 0xFF, 0xFF, 0x9B, 0x00, 0x52, 0x00, 0x00, 0x5D,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB5, 0x12, 0x9E, 0x13, 0x5D,  
	 0x53, 0x90, 0x53, 0x52, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x00,  
	 0x00, 0x12, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB6,  
	 0xFF, 0x5D, 0x55, 0x6D, 0x5D, 0x5B, 0x42, 0xBE, 0xFF, 0xFF,  
	 0xF6, 0xF6, 0xFF, 0xF7, 0x00, 0x0A, 0x52, 0x0A, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x08, 0x5D, 0xAF, 0x55, 0x53,  
	 0x07, 0xFF, 0xFF, 0xF5, 0xAB, 0x9B, 0xF7, 0x08, 0xEE, 0x52,  
	 0x52, 0x12, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF,  
	 0x5D, 0xAE, 0x9B, 0x07, 0xFF, 0xFF, 0x9A, 0x00, 0x42, 0x00,  
	 0x0A, 0x12, 0xF7, 0x5D, 0x9D, 0x5B, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x07, 0x6E, 0x5D, 0x9D, 0xFF, 0xFF, 0xFF,  
	 0x92, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB6, 0x6E,  
	 0xEF, 0xFF, 0xFF, 0x07, 0x5B, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0xAE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0xF7, 0x92, 0x00,  
	 0x00, 0x00, 0x00, 0x00, 0x40, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xF6, 0x93, 0x9A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xAE,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xEE, 0x53, 0x50, 0x00,  
	 0x40, 0x42, 0x9D, 0xF5, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x9B,  
	 0x9B, 0x52, 0x40, 0x0A, 0x52, 0x07, 0xEF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xB6, 0xFF, 0xFF, 0xED, 0x93, 0x52, 0x00, 0x00, 0x00, 0xB5,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xEF, 0xF7, 0xFF, 0xFF, 0xFF, 0xB6, 0x52,  
	 0x42, 0x00, 0x9B, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xB6, 0xF6,  
	 0xFF, 0xF6, 0xFF, 0xFF, 0x08, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0xFF, 0xFF, 0xF6, 0xFF, 0x08, 0x07,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xFF, 0xFF,  
	 0xFF, 0xF6, 0xFF, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 /* IDB_NETWORK */ 
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0x08, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x36, 0x3E, 0xFB, 0x7E, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x36, 0x37,  
	 0x36, 0xFB, 0xFB, 0xFB, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xBF, 0x37, 0x36, 0x36, 0x37, 0x37, 0xFB, 0xBE, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x1D, 0x2E, 0x37, 0x37,  
	 0xAB, 0x53, 0xFB, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x77,  
	 0x12, 0x6D, 0x36, 0x36, 0x7E, 0xBF, 0xFB, 0x3E, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x36, 0x76, 0x6F, 0x0E, 0x46, 0x57, 0x2E,  
	 0xFB, 0x37, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x2E, 0x2F, 0x45,  
	 0x01, 0x15, 0x0E, 0x16, 0x36, 0x76, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x76, 0x2F, 0x15, 0x45, 0x45, 0x45, 0x36, 0x37, 0x08,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xF6, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0x2E, 0x37, 0x2E, 0x2F,  
	 0x37, 0x37, 0x76, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0x2F, 0x2E, 0xB6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x76, 0x2F, 0x2E, 0x36, 0x36, 0x76, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x36, 0x2E, 0x2F,  
	 0x2E, 0x76, 0xFF, 0xFF, 0xFF, 0x77, 0x36, 0x2F, 0x2F, 0x7E,  
	 0xFB, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x08, 0x36, 0x36, 0x36, 0x37, 0x36, 0x2F, 0x76, 0xB7, 0x36,  
	 0x36, 0x36, 0x37, 0x36, 0xFB, 0xFB, 0x7E, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x2F, 0x2F, 0x37, 0x36, 0x36,  
	 0x37, 0x36, 0x36, 0x2F, 0x37, 0x36, 0x36, 0x36, 0x77, 0xFB,  
	 0xFB, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x36,  
	 0x36, 0x36, 0x2F, 0x36, 0x2F, 0x36, 0x37, 0x36, 0x36, 0x2F,  
	 0x2F, 0x3E, 0x3E, 0xFB, 0xFB, 0xFB, 0xBE, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x1F, 0x2E, 0x36, 0x2F, 0x36, 0x36, 0x36,  
	 0x37, 0x2E, 0x36, 0x36, 0x2E, 0x2F, 0x36, 0x37, 0x3E, 0x37,  
	 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x2F, 0x2E, 0x2F,  
	 0x2E, 0x2E, 0x37, 0x2F, 0x36, 0x36, 0x2F, 0x37, 0x36, 0x36,  
	 0x36, 0x36, 0x37, 0x3E, 0x36, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x07, 0x2E, 0x2E, 0x2E, 0x2F, 0x36, 0x2E, 0x36, 0x2F,  
	 0x36, 0x36, 0x36, 0x37, 0x2F, 0x36, 0x37, 0x36, 0x36, 0xEF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xAE, 0x2E, 0x2E, 0x2E,  
	 0x2F, 0x2F, 0x2F, 0x36, 0x2F, 0x37, 0x2E, 0x36, 0x37, 0x36,  
	 0x2E, 0x37, 0x36, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x35, 0x2F, 0x2F, 0x36, 0x2D, 0x2E, 0x2F, 0x2E, 0x2E,  
	 0x2F, 0x2E, 0x36, 0x2F, 0x36, 0x36, 0x2F, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x2D, 0x1E, 0x2E, 0x1E,  
	 0x1E, 0x1D, 0x2D, 0x2F, 0x36, 0x2F, 0x36, 0x36, 0x37, 0x36,  
	 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x9E, 0x1D, 0x1E, 0x2D, 0x2E, 0x1E, 0x2D, 0x1E, 0x2E,  
	 0x2E, 0x2F, 0x2E, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xAE, 0x5D, 0x1D,  
	 0x2E, 0x1E, 0x1D, 0x1E, 0x1D, 0x1E, 0xB6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xEF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 /* IDB_EXIT */ 
	 0x5A, 0x53, 0x52, 0x92, 0x5B, 0x53, 0x52, 0x53, 0x53, 0x5B,  
	 0x93, 0x5B, 0x9B, 0x5B, 0x53, 0x53, 0x93, 0x53, 0x5B, 0x5B,  
	 0x52, 0x53, 0x5B, 0x53, 0x92, 0x52, 0x93, 0x50, 0x00, 0x92,  
	 0x93, 0x5B, 0x53, 0x5B, 0x9B, 0x5B, 0x5A, 0x5B, 0x5A, 0x53,  
	 0x5B, 0x5A, 0x93, 0x5B, 0x9B, 0x5B, 0x92, 0x53, 0x42, 0x00,  
	 0x00, 0x00, 0x42, 0x00, 0x00, 0x93, 0x52, 0x9B, 0x9A, 0x9B,  
	 0x9B, 0x9B, 0x5B, 0x9B, 0x93, 0x9B, 0x9B, 0x5B, 0x5B, 0x53,  
	 0x53, 0x5B, 0x13, 0x00, 0x00, 0x00, 0x00, 0xAE, 0x9D, 0x9A,  
	 0x9B, 0x9B, 0x9D, 0x9B, 0x9B, 0x93, 0x9B, 0x9B, 0x9A, 0x9B,  
	 0x53, 0x9A, 0x9B, 0x9A, 0x5B, 0x5B, 0x92, 0x10, 0x00, 0x0A,  
	 0x9D, 0xB7, 0x9E, 0x5B, 0x9B, 0x93, 0x9B, 0x95, 0x9D, 0x9D,  
	 0x9B, 0x93, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x95, 0x9B, 0x9A,  
	 0x5B, 0x52, 0x00, 0x00, 0x53, 0xAE, 0xAE, 0x92, 0x93, 0x9D,  
	 0x9B, 0x9D, 0x9B, 0x9B, 0x9B, 0x9D, 0x9B, 0x9B, 0x9B, 0x9B,  
	 0x9B, 0x9A, 0x9B, 0x93, 0x53, 0x52, 0xAD, 0x50, 0x1B, 0x9E,  
	 0xF7, 0xFF, 0xB6, 0x9D, 0x9B, 0x95, 0x93, 0x9D, 0x9D, 0x9B,  
	 0x9D, 0x95, 0x9B, 0x95, 0x9B, 0x95, 0x9D, 0x9B, 0x9A, 0x5B,  
	 0xFF, 0xFF, 0x9B, 0xAE, 0xF7, 0xFF, 0x6D, 0xFF, 0xEF, 0xAB,  
	 0xAD, 0xAD, 0x9E, 0x9B, 0x9B, 0x9B, 0x9B, 0x9B, 0x9D, 0x9D,  
	 0x9B, 0x9D, 0x5B, 0x53, 0xF7, 0xFF, 0xFF, 0x93, 0xB6, 0xFF,  
	 0xF7, 0xFF, 0xFF, 0xFF, 0x93, 0xAD, 0xF7, 0x9B, 0x9D, 0x9B,  
	 0x9D, 0x95, 0x9B, 0x9D, 0x9B, 0x9B, 0x53, 0x5B, 0x53, 0x07,  
	 0xEF, 0xFF, 0xFF, 0xFF, 0x07, 0xF7, 0xF6, 0xAD, 0xFF, 0xAD,  
	 0x93, 0xAD, 0x9D, 0x95, 0x9B, 0x9D, 0x9B, 0xAD, 0x9B, 0x9D,  
	 0x53, 0x5B, 0x52, 0x07, 0xEE, 0xFF, 0xFF, 0x00, 0x93, 0x53,  
	 0x92, 0x9A, 0x9D, 0x9B, 0xAB, 0x9B, 0xAB, 0xAB, 0x9D, 0xAB,  
	 0x9B, 0x9D, 0x93, 0x9B, 0x93, 0x53, 0x53, 0x5A, 0xB6, 0xEE,  
	 0x07, 0x00, 0xAB, 0xF5, 0xAE, 0x9B, 0x9B, 0x9B, 0x95, 0xAB,  
	 0x9D, 0xAD, 0x9B, 0xAD, 0x9D, 0x9B, 0x9D, 0x9D, 0x53, 0x53,  
	 0x5B, 0x52, 0x12, 0x00, 0x00, 0x52, 0xEF, 0xFF, 0xFF, 0xFF,  
	 0x09, 0xFF, 0x07, 0xED, 0xF7, 0xEE, 0xAB, 0x9B, 0x93, 0x9B,  
	 0x9D, 0x9B, 0x5B, 0x9A, 0x9B, 0x9D, 0x00, 0x9B, 0x09, 0xFF,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07,  
	 0xAD, 0xEF, 0xEF, 0xB7, 0xEF, 0x9D, 0x9B, 0x5B, 0x5B, 0x00,  
	 0xF7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB6, 0xF7, 0xF7,  
	 0x9D, 0xF7, 0x08, 0xFF, 0x92, 0x9D, 0xF7, 0x9B, 0x93, 0x53,  
	 0x5B, 0x12, 0x50, 0x95, 0x00, 0xB5, 0xFF, 0xFF, 0x9B, 0x5B,  
	 0x53, 0x53, 0x5A, 0x9B, 0x92, 0x93, 0x93, 0x53, 0x9B, 0x9B,  
	 0x93, 0x53, 0x9B, 0x9D, 0x93, 0x53, 0x53, 0x53, 0xED, 0xFF,  
	 0xFF, 0xF5, 0x5D, 0xEF, 0x9A, 0x9B, 0x9D, 0x9D, 0xAB, 0xAD,  
	 0x9B, 0x9B, 0x9D, 0xAB, 0xAB, 0x9D, 0x93, 0x9B, 0x5A, 0x12,  
	 0x52, 0xB5, 0xFF, 0xFF, 0xFF, 0x9D, 0x07, 0x9E, 0xAE, 0x95,  
	 0x9B, 0x9B, 0x9B, 0x9D, 0x9D, 0xAB, 0x9D, 0x9D, 0x9B, 0x95,  
	 0x9D, 0x9B, 0x52, 0x92, 0x5A, 0xFF, 0xFF, 0xFF, 0xFF, 0x9A,  
	 0x13, 0x43, 0x5D, 0x9D, 0x9D, 0xAD, 0x9D, 0xAB, 0x9D, 0xAD,  
	 0x9B, 0xAD, 0xAB, 0x9B, 0x9B, 0x95, 0x5A, 0x53, 0x9A, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x42, 0x9B, 0x9B, 0x53, 0x9D, 0x9B, 0x9B,  
	 0xAD, 0x9D, 0xAD, 0x9E, 0x9D, 0xAB, 0x9D, 0x95, 0x9D, 0x9B,  
	 0x5B, 0x53, 0x43, 0x12, 0x95, 0x53, 0x52, 0x93, 0x9D, 0x9D,  
	 0x9D, 0x93, 0xAB, 0x9D, 0xAB, 0x9D, 0xF7, 0xF7, 0x9D, 0xAB,  
	 0xAB, 0x9B, 0x9D, 0x9B, 0x92, 0x53, 0x93, 0x52, 0x52, 0x53,  
	 0x5B, 0x9D, 0x9B, 0x9B, 0xAB, 0xAD, 0x9D, 0xAB, 0x9D, 0xAD,  
	 0x9D, 0x9D, 0xAB, 0x9D, 0x9B, 0x95, 0x9B, 0x95, 0x53, 0x5A,  
	 0x53, 0x9B, 0x9B, 0x9D, 0x9B, 0x9B, 0x9B, 0x9D, 0xAB, 0x9D,  
	 0xAB, 0x9B, 0xAB, 0xAB, 0xAB, 0x9D, 0x9B, 0x9D, 0xAB, 0x9D,  
	 0x9B, 0x9B, 0x52, 0x92, 0x53, 0x93, 0x9B, 0x9B, 0x9D, 0x9B,  
	 0x9B, 0x9D, 0x9B, 0x93, 0x9B, 0x9B, 0x9D, 0x93, 0x9B, 0x95,  
	 0x9B, 0xAD, 0x9B, 0x9D, 0x9B, 0x9B,  
	 /* IDB_TOOL */ 
	 0xAB, 0x9B, 0xAD, 0x9B, 0xAD, 0xAD, 0xAB, 0x9D, 0x9B, 0xAD,  
	 0x9D, 0xAD, 0xF7, 0xAD, 0x9D, 0xAD, 0xF7, 0x9B, 0x9D, 0xAD,  
	 0xAB, 0x9D, 0xAD, 0xAB, 0xAB, 0xAB, 0x9D, 0xAB, 0x9D, 0x9B,  
	 0x9B, 0xAD, 0xAB, 0xAB, 0xF7, 0xED, 0xF7, 0xF7, 0xF7, 0xED,  
	 0xB5, 0xAB, 0x9D, 0x9B, 0x9B, 0xAD, 0x9B, 0x9B, 0x9B, 0xAB,  
	 0x9D, 0xAB, 0x9D, 0xAB, 0xAD, 0xF7, 0xED, 0xAE, 0xED, 0xF7,  
	 0xF7, 0xED, 0xF7, 0xF7, 0xF7, 0xF7, 0xF5, 0xAE, 0xAD, 0x9D,  
	 0x9B, 0xAD, 0x9D, 0x9D, 0xAB, 0xAB, 0x9D, 0xF7, 0xF7, 0xF7,  
	 0xF7, 0xB5, 0xF7, 0xF7, 0xB5, 0xF7, 0xEE, 0xB5, 0xED, 0xF7,  
	 0xF7, 0xED, 0xF7, 0xAB, 0xAD, 0x9B, 0x42, 0x52, 0x9B, 0xF7,  
	 0xF7, 0xAE, 0xF7, 0xAE, 0xF7, 0xF7, 0xED, 0xF7, 0xAE, 0xF7,  
	 0xF7, 0xF7, 0xF7, 0xAE, 0xF7, 0xF7, 0xF7, 0xAE, 0x9B, 0xAB,  
	 0x52, 0x12, 0x01, 0x5A, 0xF7, 0xED, 0xB5, 0xED, 0xF7, 0xAE,  
	 0xED, 0xB5, 0xF7, 0xED, 0xF7, 0xF7, 0xED, 0xF7, 0xED, 0xF7,  
	 0xF7, 0xF5, 0xF7, 0x9D, 0x9B, 0x40, 0x10, 0x0A, 0x12, 0x53,  
	 0xF7, 0xAE, 0xF7, 0xF7, 0x6D, 0xAE, 0xED, 0x07, 0xB6, 0xB5,  
	 0xF7, 0xF7, 0xB5, 0xAE, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xAD,  
	 0x52, 0x42, 0x42, 0x52, 0x0A, 0x9B, 0xB5, 0xF5, 0x42, 0x12,  
	 0x6F, 0xF7, 0xEE, 0x07, 0xED, 0xF7, 0xF7, 0xED, 0xF7, 0xF7,  
	 0xED, 0xAE, 0xAD, 0xF7, 0xF7, 0xAB, 0x52, 0x42, 0x13, 0x92,  
	 0x42, 0x9B, 0x07, 0xF7, 0x13, 0xB6, 0xED, 0x07, 0x07, 0xF5,  
	 0xAE, 0xF7, 0xF7, 0xAE, 0xF7, 0xB5, 0xF7, 0xF7, 0xF7, 0xB5,  
	 0xAE, 0x9A, 0x40, 0x52, 0x53, 0x52, 0x52, 0xAD, 0x93, 0x77,  
	 0xAF, 0xB6, 0xAE, 0xAE, 0xF7, 0xF7, 0xF7, 0xB5, 0xED, 0xF7,  
	 0xF7, 0xB5, 0xED, 0xF7, 0xEE, 0xB5, 0xAB, 0x52, 0x40, 0x53,  
	 0x92, 0x52, 0x93, 0x6D, 0xB6, 0xB6, 0xB6, 0xB6, 0xAF, 0x76,  
	 0x9E, 0xAD, 0xF7, 0xF7, 0xED, 0xAE, 0xF7, 0xF7, 0xF7, 0xF7,  
	 0xEE, 0xF7, 0xAB, 0x40, 0x42, 0x53, 0x5B, 0x42, 0xAE, 0xAE,  
	 0xB7, 0xB7, 0xB6, 0xBF, 0xB7, 0x6D, 0x9D, 0xAE, 0xF7, 0xF7,  
	 0xF7, 0xED, 0xB5, 0xF7, 0xB6, 0xB6, 0x07, 0xB5, 0x92, 0x50,  
	 0x42, 0xEB, 0xB6, 0xAE, 0xB6, 0x5D, 0xF7, 0xB6, 0xB7, 0xB6,  
	 0x5D, 0xF7, 0xB6, 0xED, 0xF7, 0xF7, 0xAE, 0xF7, 0xF5, 0x07,  
	 0x07, 0x07, 0x08, 0x9B, 0x6E, 0xB6, 0xB6, 0xAF, 0xAE, 0x50,  
	 0x52, 0xAE, 0xB7, 0xB7, 0x9F, 0xAB, 0xF7, 0xF7, 0xF7, 0xF7,  
	 0xED, 0xF7, 0xEE, 0xB6, 0xEE, 0x9D, 0xAE, 0x6E, 0xB6, 0xB7,  
	 0x07, 0xB6, 0x50, 0x52, 0x52, 0x6E, 0x9B, 0x9B, 0x6E, 0x9B,  
	 0xF7, 0xF7, 0xF5, 0xAE, 0xF7, 0xB5, 0xEE, 0xF5, 0x07, 0x12,  
	 0x0A, 0x01, 0x5D, 0xB7, 0xB6, 0xB7, 0x0A, 0x00, 0xB6, 0xAE,  
	 0x42, 0x00, 0x9A, 0xAD, 0xED, 0xF7, 0xF7, 0xF7, 0xED, 0xF7,  
	 0xAE, 0xF5, 0xB6, 0xEE, 0xAB, 0xAB, 0x52, 0x1E, 0xB6, 0xB7,  
	 0xB7, 0xB7, 0xB7, 0x90, 0x00, 0x52, 0x55, 0x52, 0xB5, 0xF7,  
	 0xF7, 0xF7, 0xB5, 0xF7, 0xED, 0x07, 0x07, 0x07, 0x07, 0x07,  
	 0x07, 0x52, 0xBE, 0x07, 0xAE, 0x5A, 0xBF, 0x9D, 0x00, 0x9B,  
	 0x1D, 0xF7, 0xF7, 0xED, 0xF7, 0xEE, 0xF7, 0xED, 0xF7, 0xED,  
	 0xB6, 0xEE, 0xB6, 0xF5, 0x07, 0x9B, 0x5E, 0xB6, 0x5D, 0xBF,  
	 0x53, 0xAE, 0xB6, 0xAE, 0x12, 0x9D, 0xF7, 0xF7, 0xF7, 0xF7,  
	 0xF7, 0xB5, 0xF7, 0xF7, 0xB5, 0xF5, 0xB6, 0xB6, 0x07, 0xED,  
	 0x13, 0xAE, 0x5D, 0xB7, 0xB7, 0xAE, 0xAE, 0x15, 0x9B, 0xAB,  
	 0xAE, 0xF7, 0xF7, 0xF7, 0xEE, 0xF7, 0xF7, 0xED, 0xF7, 0xF7,  
	 0xED, 0xF7, 0xB5, 0xEE, 0x9A, 0x5D, 0xB7, 0x00, 0xB7, 0xB7,  
	 0x1D, 0x50, 0xAD, 0xAB, 0xF7, 0xF7, 0xED, 0xF7, 0xF7, 0xF7,  
	 0xF7, 0xAE, 0xF5, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7, 0xED, 0x52,  
	 0x13, 0x55, 0x1D, 0x43, 0x40, 0x9D, 0x9B, 0x9D, 0xF7, 0xB5,  
	 0xF7, 0xF7, 0xB5, 0xF7, 0xED, 0xF7, 0xF7, 0xF7, 0xF7, 0xF7,  
	 0xF7, 0xED, 0xF7, 0xF7, 0x9A, 0x0A, 0x10, 0x52, 0xAB, 0xAD,  
	 0x9B, 0xAB, 0xF7, 0xED, 0xAE, 0xED, 0xF7, 0xF7, 0xF7, 0xF7,  
	 0xF7, 0xF7, 0xED, 0xAE, 0xF7, 0xF7, 0xAE, 0xED, 0xB5, 0xF7,  
	 0xF7, 0xF7, 0x9B, 0x9D, 0xAB, 0x9D,  
	 /* IDB_BG */ 
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xBE, 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x6E, 0x76, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x08, 0xBF, 0xEF, 0x08, 0xF6, 0xEF, 0x08, 0x08, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6,  
	 0xEF, 0xBF, 0x36, 0x37, 0x36, 0xBE, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB6, 0x36, 0x77, 0x36, 0x2E,  
	 0x37, 0x37, 0xB6, 0x76, 0xB7, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x76, 0x76, 0x36, 0x2F,  
	 0x36, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6,  
	 0x36, 0x37, 0x2E, 0x37, 0x36, 0x37, 0x36, 0x36, 0x36, 0x7F,  
	 0x76, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB7, 0x36, 0x37, 0x36, 0x36, 0x2F, 0xBF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0x76, 0x37, 0x36, 0x2F, 0x36, 0x36,  
	 0x2F, 0x36, 0x2F, 0x2E, 0x37, 0x36, 0x76, 0x76, 0xB7, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xFF, 0x36, 0x2F, 0x2E,  
	 0x36, 0x36, 0x37, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x76,  
	 0x2F, 0x36, 0x36, 0x36, 0x37, 0x2F, 0x36, 0x36, 0x37, 0x36,  
	 0x36, 0x2E, 0x37, 0xB6, 0x7F, 0xB7, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x77, 0x36, 0x36, 0x2F, 0x2F, 0x36, 0x2E,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0xBE, 0x37, 0x2F, 0x36, 0x2F, 0x2F,  
	 0x36, 0x36, 0x2F, 0x36, 0x2F, 0x36, 0x37, 0x2E, 0x37, 0x36,  
	 0x76, 0x76, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x6E,  
	 0x36, 0x37, 0x36, 0x36, 0x36, 0x2F, 0x76, 0xB7, 0xB6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF,  
	 0x37, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x37,  
	 0x36, 0x2E, 0x37, 0x36, 0x36, 0x2F, 0x7E, 0xB7, 0x76, 0xEF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xEF, 0xBE, 0x7E, 0xB7, 0x36, 0x2F, 0x36, 0x36, 0x2F,  
	 0x37, 0x36, 0x36, 0x37, 0x36, 0x37, 0xB7, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0x7E, 0x36, 0x2F, 0x36, 0x2F,  
	 0x36, 0x37, 0x2F, 0x2F, 0x36, 0x2F, 0x7E, 0x76, 0x36, 0x2F,  
	 0x36, 0x2E, 0x77, 0x7E, 0xBE, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB6, 0x7E, 0x77, 0x76,  
	 0x37, 0x36, 0x36, 0x2F, 0x36, 0x36, 0x36, 0x2E, 0x2F, 0x36,  
	 0x36, 0x2F, 0x36, 0x37, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xEF, 0x77, 0x08, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x08, 0x37, 0x36, 0x37, 0x36, 0x37, 0x36, 0x2E, 0x36, 0x36,  
	 0x36, 0x2E, 0x37, 0x77, 0x2E, 0x36, 0x37, 0x36, 0x36, 0x77,  
	 0xB7, 0xBE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xF6, 0xB6, 0xB7, 0x76, 0x77, 0x76, 0xAE, 0x37, 0x76, 0x36,  
	 0x37, 0x2F, 0x36, 0x37, 0x36, 0x37, 0x36, 0x36, 0x36, 0x36,  
	 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0x77, 0x36, 0x76, 0xB6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x36, 0x37, 0x36,  
	 0x2E, 0x36, 0x37, 0x2F, 0x36, 0x37, 0x37, 0x3E, 0x2F, 0x76,  
	 0x37, 0x2E, 0x36, 0x2F, 0x36, 0x3E, 0x76, 0xBE, 0xF6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB6, 0xBE, 0xBE, 0x7E,  
	 0xAF, 0x76, 0x76, 0x36, 0x76, 0xB6, 0xB6, 0x36, 0x2F, 0x36,  
	 0x2E, 0x2F, 0x36, 0x37, 0x2F, 0x2F, 0x36, 0xB6, 0xBF, 0xB7,  
	 0x37, 0x36, 0x2F, 0x37, 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xF6, 0x76, 0x37, 0x2E, 0x37, 0x36, 0x2F, 0x36, 0x36,  
	 0x37, 0x76, 0x2E, 0x76, 0x36, 0x36, 0xFB, 0x36, 0x37, 0x36,  
	 0x2F, 0x36, 0x77, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xF6, 0xB6, 0xB7, 0xB6, 0x76, 0xB6, 0xFF, 0xFF,  
	 0xF6, 0xFF, 0xBF, 0x2E, 0x37, 0x36, 0x36, 0x37, 0x36, 0x36,  
	 0x36, 0x36, 0x37, 0x2F, 0x36, 0x36, 0x36, 0x37, 0x36, 0x36,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x76, 0x77, 0xBE,  
	 0x36, 0x36, 0x37, 0x2E, 0x36, 0x2F, 0x36, 0x3E, 0x37, 0xB6,  
	 0x77, 0x2F, 0x36, 0x36, 0x2F, 0x36, 0x2E, 0x37, 0xB6, 0x76,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xFF, 0xFF, 0xBE,  
	 0xB6, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0x09, 0xF6, 0x76, 0x36,  
	 0x36, 0x2F, 0x37, 0x36, 0x2F, 0x36, 0x2F, 0x36, 0x36, 0x36,  
	 0x36, 0x37, 0x2F, 0x2E, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xBE, 0xB6, 0x7E, 0x77, 0x7E, 0xBE, 0x7E,  
	 0x3E, 0x36, 0x2F, 0x76, 0x37, 0x3E, 0x7E, 0x36, 0x36, 0x2F,  
	 0x36, 0x36, 0x37, 0x36, 0x37, 0xB6, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0x9B, 0x42, 0xAD, 0x36, 0x37, 0x2E, 0x36, 0x36, 0x2E,  
	 0x36, 0x36, 0x36, 0x2F, 0x36, 0x2F, 0x36, 0x2E, 0x36, 0x37,  
	 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6,  
	 0xB5, 0xBF, 0xB6, 0xF6, 0xFF, 0xB7, 0xB7, 0x2F, 0x36, 0xFB,  
	 0x6E, 0x3E, 0xB7, 0x77, 0x36, 0x36, 0x37, 0x37, 0x2E, 0x36,  
	 0x76, 0xBE, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x9A, 0x52, 0x6E,  
	 0x37, 0x36, 0x2F, 0x36, 0x37, 0x36, 0x37, 0x2F, 0xBE, 0x37,  
	 0x36, 0x36, 0x37, 0x2F, 0x36, 0x6E, 0xBE, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0xFF, 0xF6, 0xFF,  
	 0xFF, 0xBF, 0x7E, 0x36, 0x36, 0x2F, 0x36, 0x37, 0x7E, 0xB6,  
	 0x36, 0x2F, 0x2E, 0x36, 0x2E, 0x37, 0x37, 0xBE, 0xF6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x07, 0xFF, 0xFF, 0xF6, 0x09, 0x6F, 0x36, 0x36, 0x37, 0x36,  
	 0x37, 0x2E, 0x2F, 0xFF, 0x76, 0x36, 0x2F, 0x36, 0x36, 0x36,  
	 0x2E, 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBE, 0xB7, 0xB7,  
	 0x36, 0x36, 0x36, 0x36, 0x77, 0x7E, 0x2F, 0x36, 0x36, 0x37,  
	 0x37, 0x36, 0x6E, 0xB6, 0xEF, 0xFF, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xEF, 0x07, 0xFF, 0xFF,  
	 0xFF, 0xBE, 0x36, 0x2F, 0x36, 0x2F, 0x2E, 0x36, 0xFF, 0xB7,  
	 0x37, 0x36, 0x2F, 0x36, 0x37, 0x76, 0xF6, 0xFF, 0xF6, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xEF, 0xBE, 0x7E, 0x36, 0x2F, 0x36, 0x2F,  
	 0xBE, 0x76, 0x37, 0x36, 0x37, 0x36, 0x2E, 0x36, 0x77, 0xBE,  
	 0xFF, 0xF6, 0xB6, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0x07, 0xFF, 0xFF, 0xFF, 0x09, 0xEE, 0x2E, 0x37,  
	 0x36, 0x36, 0x2F, 0xAD, 0x07, 0xB6, 0x7E, 0x2E, 0x37, 0x36,  
	 0x6E, 0xBE, 0xFF, 0x08, 0x08, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xB7, 0x77, 0x37, 0x37, 0x36, 0x36, 0x77, 0x77, 0x36, 0x2E,  
	 0x2F, 0x36, 0x37, 0x77, 0x76, 0xBF, 0xFF, 0xB7, 0xB7, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB6, 0x9B, 0xF7, 0x9B, 0xAE, 0xBF, 0xEF, 0x9B, 0x50,  
	 0x93, 0xEF, 0xB6, 0x77, 0x6E, 0x76, 0x77, 0xBE, 0xFF, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBE, 0x76, 0x2E, 0x36,  
	 0x36, 0x2F, 0x7E, 0x76, 0x2F, 0x36, 0x36, 0x2F, 0x36, 0x7E,  
	 0x7E, 0xEF, 0xBF, 0x7E, 0xB7, 0xFF, 0xFF, 0xFF, 0xBF, 0x08,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0xED, 0x12, 0x93,  
	 0x52, 0xAE, 0xFF, 0xFF, 0xB5, 0x42, 0x07, 0xFF, 0xFF, 0xB7,  
	 0x7E, 0x7E, 0x77, 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xB7, 0x7E, 0x2F, 0x37, 0x36, 0x37, 0x7E, 0x36,  
	 0x36, 0x37, 0x36, 0x36, 0x77, 0x76, 0xB7, 0xFF, 0xB7, 0xBF,  
	 0xFF, 0xFF, 0xB6, 0x2E, 0x2E, 0x2F, 0x36, 0x37, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xF6, 0xF7, 0x93, 0x5A, 0x9D, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0x76, 0xB6, 0x77, 0xBE,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x76,  
	 0x36, 0x2F, 0x36, 0x36, 0x37, 0x37, 0x36, 0x36, 0x2F, 0x36,  
	 0x7E, 0xB7, 0xBE, 0xF6, 0x76, 0xB6, 0xFF, 0xF6, 0x76, 0x2F,  
	 0x36, 0x36, 0x2E, 0x2F, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,  
	 0xF6, 0x07, 0xFF, 0xF6, 0xFF, 0x07, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xF6, 0x76, 0x77, 0xBE, 0x08, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x76, 0x2F, 0x36, 0x36, 0x2F,  
	 0x36, 0x36, 0x2F, 0x2E, 0xFB, 0x76, 0xB7, 0x08, 0xF6, 0xB7,  
	 0x7E, 0xFF, 0xFF, 0xEF, 0x76, 0x37, 0x36, 0x2F, 0x36, 0x36,  
	 0x76, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x08, 0xFF, 0x08,  
	 0x07, 0xB6, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0x08, 0xB6, 0xBE,  
	 0xB6, 0xBE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xB6, 0x7E, 0x37, 0x2E, 0x37, 0x36, 0x36, 0x37, 0x3E, 0x36,  
	 0xB7, 0x76, 0x7E, 0xFF, 0xF6, 0xB6, 0xBF, 0xFF, 0xFF, 0xFF,  
	 0x37, 0x2E, 0x36, 0x2F, 0x36, 0x37, 0x36, 0xEF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0xF6, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0xF6, 0xBE, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x77, 0x3E, 0x37,  
	 0x36, 0x2F, 0x2E, 0x36, 0x37, 0x7E, 0x77, 0x7E, 0xB6, 0xFF,  
	 0x76, 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x76, 0x36, 0x36,  
	 0x2E, 0x2F, 0x36, 0xB7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xB6, 0x76, 0x2E, 0x36, 0x36, 0x37, 0x36,  
	 0x37, 0xB6, 0x7E, 0x76, 0xBF, 0xFF, 0x76, 0xBE, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0x36, 0x37, 0x37, 0x36, 0x76, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF,  
	 0x3E, 0x2F, 0x37, 0x2F, 0x36, 0x36, 0x77, 0x7E, 0xB6, 0xB7,  
	 0xFF, 0xB7, 0x7E, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x2E, 0x36, 0x36, 0x36, 0x6E, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x08, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x3E, 0x36, 0x36, 0x2E,  
	 0x36, 0x77, 0xBE, 0xB7, 0xBF, 0x08, 0xB7, 0x77, 0xBE, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x37, 0x2E, 0x37, 0x2E,  
	 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xBE, 0xB6,  
	 0xBF, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xF6, 0x77, 0x37, 0x36, 0x37, 0x37, 0x76, 0x76,  
	 0xFF, 0xFF, 0xBE, 0x76, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB6, 0x36, 0x37, 0x36, 0x37, 0x76, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0x76, 0x2E, 0x37, 0x2F, 0x36, 0x37, 0x36, 0xBE,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7F,  
	 0x36, 0x36, 0x2E, 0x36, 0x77, 0x7E, 0xEF, 0xEF, 0x37, 0x7E,  
	 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBE, 0x36, 0x2F,  
	 0x36, 0x2E, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0x76, 0x37, 0x36,  
	 0x36, 0x36, 0x36, 0x2E, 0x36, 0xB7, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x76, 0xFB, 0x37, 0x36,  
	 0x76, 0xBE, 0xBE, 0xBE, 0x36, 0xB6, 0xB7, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0x2E, 0x36, 0x2F, 0x76, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0x76, 0x2F, 0x36, 0x2F, 0x36, 0x2F, 0x37, 0x37,  
	 0x36, 0x36, 0x08, 0xFF, 0xBF, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xBE, 0x77, 0x76, 0x7E, 0x77, 0xB7, 0xB6, 0x77,  
	 0x77, 0x7E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0x08, 0xAD, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x36, 0x36,  
	 0x36, 0x36, 0x37, 0x36, 0x36, 0x36, 0x2F, 0x36, 0xEF, 0xFF,  
	 0xB6, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB6,  
	 0xBE, 0xB7, 0xBE, 0xBE, 0xF6, 0x36, 0x7E, 0x76, 0xB6, 0xF6,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0x2F, 0x2E, 0x37, 0x2E, 0x2F, 0x36, 0x2E,  
	 0x37, 0x36, 0x2F, 0x76, 0xF6, 0xFF, 0xBE, 0xBE, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xF6, 0x36, 0x77, 0x7E, 0xB7, 0xB6, 0x08, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBE, 0x36,  
	 0x37, 0x36, 0x37, 0x36, 0xB7, 0xBF, 0x36, 0x37, 0xB6, 0xFF,  
	 0xFF, 0xFF, 0xB6, 0xB7, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x37, 0x77, 0x76,  
	 0xB6, 0xBE, 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0x2F, 0x36, 0x37, 0x2E, 0xB7,  
	 0xFF, 0xFF, 0xBE, 0xB6, 0xF6, 0xFF, 0xFF, 0xFF, 0xB6, 0xBE,  
	 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xB7, 0x3E, 0x7E, 0x76, 0x7F, 0xB7, 0xB7, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB5, 0x2E, 0x3E, 0xB7, 0xFF, 0xFF, 0xFF, 0xF6, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xB6, 0x77, 0xF6, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0x36,  
	 0x77, 0xB7, 0x7E, 0x76, 0xBE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x09, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB7,  
	 0x7E, 0x76, 0x08, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x3E, 0x76, 0x7E, 0x77, 0x7E,  
	 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x7E, 0x37, 0xBF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB7, 0xBE, 0x07, 0xEF,  
	 0xB6, 0x2F, 0x76, 0x77, 0xB6, 0x76, 0x77, 0xBE, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xB7,  
	 0xBE, 0xB6, 0x36, 0x36, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xB6, 0x7E, 0x76, 0xFB, 0x7F, 0x36, 0x36, 0x37, 0x7E,  
	 0xB7, 0x7E, 0xBE, 0x7F, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0xBE, 0xB7, 0xBE, 0x2F, 0x76,  
	 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x37, 0x37, 0x36,  
	 0x36, 0x36, 0x2F, 0x36, 0x36, 0x36, 0x36, 0x37, 0x36, 0x76,  
	 0x7F, 0xB6, 0xEF, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xBE, 0x77, 0x76, 0x7F, 0x36, 0x36, 0xEF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0x76, 0x37, 0x36, 0x2E, 0x2F, 0x36, 0x2E, 0x37,  
	 0x36, 0x2F, 0x36, 0x37, 0x37, 0x2E, 0x36, 0x36, 0x36, 0x37,  
	 0xB6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x08,  
	 0xB7, 0xEF, 0x08, 0xB6, 0x76, 0x77, 0x76, 0x76, 0xBE, 0x76,  
	 0x37, 0x36, 0x08, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xEF, 0x1E, 0x3E,  
	 0x2E, 0x37, 0x36, 0x36, 0x37, 0x36, 0x36, 0x2F, 0x36, 0x36,  
	 0x36, 0x36, 0x37, 0x2F, 0x37, 0x36, 0x76, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xB7, 0x2E, 0x36, 0x36, 0x36, 0x36,  
	 0x37, 0x36, 0x2E, 0x37, 0x77, 0x7F, 0x7E, 0xB6, 0xEF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0x6F, 0x36, 0x2F, 0xB6, 0xF6, 0xFF,  
	 0xF6, 0xF6, 0xB7, 0x36, 0x36, 0x2F, 0x2F, 0x36, 0x2E, 0x36,  
	 0x36, 0x2E, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xB6, 0x36, 0x37, 0x37, 0x2F, 0x37, 0x2E, 0x2F, 0x36, 0x36,  
	 0x3E, 0xB6, 0xFF, 0xF6, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xBE, 0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xBF, 0xBF, 0xB6, 0xBF, 0xB7, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF6, 0x37, 0x2E, 0x36,  
	 0x36, 0x36, 0x36, 0x36, 0x37, 0x36, 0x6E, 0x7E, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xF6, 0xB7, 0xB7, 0x36, 0x6F, 0xFB, 0x36,  
	 0x2F, 0x36, 0x6D, 0x76, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xBF, 0x76, 0x76, 0xBE, 0xBF, 0xB7, 0x7E, 0xF6,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,  
	 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF 
	},
	{/* Fonts data struct */
	 /* The character 0x20 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x21 of the Courier */
	 0x00, 0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x22 of the Courier */
	 0x00, 0x00, 0x14, 0x14, 0x14, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x23 of the Courier */
	 0x00, 0x00, 0x0A, 0x0A, 0x3F, 0x14, 0x14, 0x14, 0x7E, 0x28,  
	 0x28, 0x00, 0x00,  
	 /* The character 0x24 of the Courier */
	 0x00, 0x00, 0x08, 0x1C, 0x22, 0x20, 0x1C, 0x02, 0x22, 0x1C,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x25 of the Courier */
	 0x00, 0x00, 0x20, 0x51, 0x22, 0x04, 0x08, 0x10, 0x22, 0x45,  
	 0x02, 0x00, 0x00,  
	 /* The character 0x26 of the Courier */
	 0x00, 0x00, 0x18, 0x20, 0x20, 0x10, 0x30, 0x49, 0x4A, 0x44,  
	 0x3B, 0x00, 0x00,  
	 /* The character 0x27 of the Courier */
	 0x00, 0x00, 0x08, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x28 of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x08, 0x10, 0x10, 0x10, 0x10, 0x10,  
	 0x08, 0x08, 0x04,  
	 /* The character 0x29 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x08, 0x04, 0x04, 0x04, 0x04, 0x04,  
	 0x08, 0x08, 0x10,  
	 /* The character 0x2A of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x36, 0x1C, 0x7F, 0x1C, 0x36, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x2B of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x08, 0x7F, 0x08, 0x08,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x2C of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x08, 0x10, 0x00,  
	 /* The character 0x2D of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x2E of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x2F of the Courier */
	 0x00, 0x00, 0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x30 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x31 of the Courier */
	 0x00, 0x00, 0x08, 0x38, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x32 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x02, 0x02, 0x04, 0x08, 0x10, 0x20,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x33 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x02, 0x02, 0x0C, 0x02, 0x02, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x34 of the Courier */
	 0x00, 0x00, 0x04, 0x0C, 0x0C, 0x14, 0x14, 0x24, 0x3E, 0x04,  
	 0x0E, 0x00, 0x00,  
	 /* The character 0x35 of the Courier */
	 0x00, 0x00, 0x3E, 0x20, 0x20, 0x20, 0x3C, 0x02, 0x02, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x36 of the Courier */
	 0x00, 0x00, 0x0C, 0x10, 0x20, 0x20, 0x3C, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x37 of the Courier */
	 0x00, 0x00, 0x3E, 0x22, 0x02, 0x04, 0x04, 0x08, 0x08, 0x10,  
	 0x10, 0x00, 0x00,  
	 /* The character 0x38 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x22, 0x22, 0x1C, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x39 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x22, 0x22, 0x1E, 0x02, 0x02, 0x04,  
	 0x18, 0x00, 0x00,  
	 /* The character 0x3A of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x3B of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00,  
	 0x08, 0x10, 0x00,  
	 /* The character 0x3C of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x04, 0x08, 0x10, 0x20, 0x10, 0x08,  
	 0x04, 0x00, 0x00,  
	 /* The character 0x3D of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3E, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x3E of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x10, 0x08, 0x04, 0x02, 0x04, 0x08,  
	 0x10, 0x00, 0x00,  
	 /* The character 0x3F of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x02, 0x02, 0x04, 0x08, 0x08, 0x00,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x40 of the Courier */
	 0x00, 0x00, 0x1E, 0x21, 0x4D, 0x55, 0x55, 0x55, 0x4E, 0x20,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x41 of the Courier */
	 0x00, 0x00, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x42 of the Courier */
	 0x00, 0x00, 0x7E, 0x21, 0x21, 0x21, 0x3E, 0x21, 0x21, 0x21,  
	 0x7E, 0x00, 0x00,  
	 /* The character 0x43 of the Courier */
	 0x00, 0x00, 0x1E, 0x21, 0x40, 0x40, 0x40, 0x40, 0x40, 0x21,  
	 0x1E, 0x00, 0x00,  
	 /* The character 0x44 of the Courier */
	 0x00, 0x00, 0x7C, 0x22, 0x21, 0x21, 0x21, 0x21, 0x21, 0x22,  
	 0x7C, 0x00, 0x00,  
	 /* The character 0x45 of the Courier */
	 0x00, 0x00, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0x46 of the Courier */
	 0x00, 0x00, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x20,  
	 0x78, 0x00, 0x00,  
	 /* The character 0x47 of the Courier */
	 0x00, 0x00, 0x1E, 0x21, 0x40, 0x40, 0x40, 0x47, 0x41, 0x21,  
	 0x1E, 0x00, 0x00,  
	 /* The character 0x48 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x22, 0x22, 0x3E, 0x22, 0x22, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x49 of the Courier */
	 0x00, 0x00, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x4A of the Courier */
	 0x00, 0x00, 0x1E, 0x04, 0x04, 0x04, 0x04, 0x04, 0x44, 0x44,  
	 0x38, 0x00, 0x00,  
	 /* The character 0x4B of the Courier */
	 0x00, 0x00, 0x73, 0x22, 0x24, 0x24, 0x28, 0x38, 0x24, 0x22,  
	 0x73, 0x00, 0x00,  
	 /* The character 0x4C of the Courier */
	 0x00, 0x00, 0x7C, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x11,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0x4D of the Courier */
	 0x00, 0x00, 0x63, 0x22, 0x36, 0x36, 0x2A, 0x2A, 0x22, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x4E of the Courier */
	 0x00, 0x00, 0x67, 0x22, 0x32, 0x32, 0x2A, 0x26, 0x26, 0x22,  
	 0x72, 0x00, 0x00,  
	 /* The character 0x4F of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x50 of the Courier */
	 0x00, 0x00, 0x7E, 0x21, 0x21, 0x21, 0x3E, 0x20, 0x20, 0x20,  
	 0x78, 0x00, 0x00,  
	 /* The character 0x51 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x1B, 0x00,  
	 /* The character 0x52 of the Courier */
	 0x00, 0x00, 0x7E, 0x21, 0x21, 0x21, 0x3E, 0x24, 0x24, 0x22,  
	 0x73, 0x00, 0x00,  
	 /* The character 0x53 of the Courier */
	 0x00, 0x00, 0x3E, 0x41, 0x40, 0x40, 0x3E, 0x01, 0x01, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x54 of the Courier */
	 0x00, 0x00, 0x7F, 0x49, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x55 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x56 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x22, 0x22, 0x14, 0x14, 0x14, 0x08,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x57 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x22, 0x22, 0x2A, 0x2A, 0x2A, 0x14,  
	 0x14, 0x00, 0x00,  
	 /* The character 0x58 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x14, 0x14, 0x08, 0x14, 0x14, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x59 of the Courier */
	 0x00, 0x00, 0x77, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x08,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0x5A of the Courier */
	 0x00, 0x00, 0x7F, 0x42, 0x04, 0x04, 0x08, 0x10, 0x10, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0x5B of the Courier */
	 0x00, 0x00, 0x1C, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,  
	 0x10, 0x10, 0x1C,  
	 /* The character 0x5C of the Courier */
	 0x00, 0x00, 0x00, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x5D of the Courier */
	 0x00, 0x00, 0x1C, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,  
	 0x04, 0x04, 0x1C,  
	 /* The character 0x5E of the Courier */
	 0x00, 0x08, 0x14, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x5F of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0xFF,  
	 /* The character 0x60 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x61 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0x62 of the Courier */
	 0x00, 0x00, 0x60, 0x20, 0x20, 0x3E, 0x21, 0x21, 0x21, 0x21,  
	 0x7E, 0x00, 0x00,  
	 /* The character 0x63 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x41, 0x40, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x64 of the Courier */
	 0x00, 0x00, 0x06, 0x02, 0x02, 0x3E, 0x42, 0x42, 0x42, 0x42,  
	 0x3F, 0x00, 0x00,  
	 /* The character 0x65 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x41, 0x7F, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x66 of the Courier */
	 0x00, 0x00, 0x0C, 0x10, 0x10, 0x3C, 0x10, 0x10, 0x10, 0x10,  
	 0x3C, 0x00, 0x00,  
	 /* The character 0x67 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x42, 0x42, 0x42, 0x3E,  
	 0x02, 0x02, 0x3C,  
	 /* The character 0x68 of the Courier */
	 0x00, 0x00, 0x60, 0x20, 0x20, 0x2C, 0x32, 0x22, 0x22, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x69 of the Courier */
	 0x00, 0x00, 0x08, 0x00, 0x00, 0x38, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x6A of the Courier */
	 0x00, 0x00, 0x04, 0x00, 0x00, 0x3C, 0x04, 0x04, 0x04, 0x04,  
	 0x04, 0x04, 0x38,  
	 /* The character 0x6B of the Courier */
	 0x00, 0x00, 0x60, 0x20, 0x20, 0x26, 0x24, 0x28, 0x38, 0x24,  
	 0x63, 0x00, 0x00,  
	 /* The character 0x6C of the Courier */
	 0x00, 0x00, 0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x6D of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x74, 0x2A, 0x2A, 0x2A, 0x2A,  
	 0x6B, 0x00, 0x00,  
	 /* The character 0x6E of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x6C, 0x32, 0x22, 0x22, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x6F of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x70 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x21, 0x21, 0x21, 0x21,  
	 0x3E, 0x20, 0x70,  
	 /* The character 0x71 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x42, 0x42, 0x42, 0x42,  
	 0x3E, 0x02, 0x07,  
	 /* The character 0x72 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0x19, 0x10, 0x10, 0x10,  
	 0x7C, 0x00, 0x00,  
	 /* The character 0x73 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x41, 0x38, 0x06, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0x74 of the Courier */
	 0x00, 0x00, 0x00, 0x10, 0x10, 0x3C, 0x10, 0x10, 0x10, 0x12,  
	 0x0C, 0x00, 0x00,  
	 /* The character 0x75 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x22, 0x22, 0x22, 0x26,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0x76 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x22, 0x22, 0x14, 0x14,  
	 0x08, 0x00, 0x00,  
	 /* The character 0x77 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x22, 0x2A, 0x2A, 0x14,  
	 0x14, 0x00, 0x00,  
	 /* The character 0x78 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x22, 0x1C, 0x1C, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0x79 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x22, 0x22, 0x14, 0x14,  
	 0x08, 0x08, 0x30,  
	 /* The character 0x7A of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x44, 0x08, 0x10, 0x22,  
	 0x7E, 0x00, 0x00,  
	 /* The character 0x7B of the Courier */
	 0x00, 0x00, 0x06, 0x08, 0x08, 0x08, 0x08, 0x30, 0x08, 0x08,  
	 0x08, 0x08, 0x06,  
	 /* The character 0x7C of the Courier */
	 0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x08, 0x08, 0x08,  
	 /* The character 0x7D of the Courier */
	 0x00, 0x00, 0x30, 0x08, 0x08, 0x08, 0x08, 0x06, 0x08, 0x08,  
	 0x08, 0x08, 0x30,  
	 /* The character 0x7E of the Courier */
	 0x00, 0x00, 0x00, 0x31, 0x49, 0x46, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x7F of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x80 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x81 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x82 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x83 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x84 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x85 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x86 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x87 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x88 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x89 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8A of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8B of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8C of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8D of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8E of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x8F of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x90 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x91 of the Courier */
	 0x00, 0x00, 0x08, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x92 of the Courier */
	 0x00, 0x00, 0x08, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0x93 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x94 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x95 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x96 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x97 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x98 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x99 of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9A of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9B of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9C of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9D of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9E of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0x9F of the Courier */
	 0x00, 0x00, 0x00, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C, 0x1C,  
	 0x1C, 0x1C, 0x00,  
	 /* The character 0xA0 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xA1 of the Courier */
	 0x00, 0x00, 0x08, 0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x08, 0x00, 0x00,  
	 /* The character 0xA2 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x08, 0x1C, 0x22, 0x20, 0x22, 0x1C,  
	 0x08, 0x00, 0x00,  
	 /* The character 0xA3 of the Courier */
	 0x00, 0x00, 0x00, 0x18, 0x24, 0x20, 0x10, 0x3C, 0x10, 0x10,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xA4 of the Courier */
	 0x00, 0x00, 0x41, 0x3E, 0x22, 0x22, 0x22, 0x3E, 0x41, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xA5 of the Courier */
	 0x00, 0x00, 0x00, 0x77, 0x22, 0x7F, 0x14, 0x7F, 0x08, 0x08,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xA6 of the Courier */
	 0x00, 0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x08, 0x08,  
	 0x08, 0x08, 0x08,  
	 /* The character 0xA7 of the Courier */
	 0x00, 0x00, 0x1E, 0x22, 0x50, 0x48, 0x24, 0x12, 0x0A, 0x44,  
	 0x78, 0x00, 0x00,  
	 /* The character 0xA8 of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xA9 of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x4D, 0x51, 0x51, 0x4D, 0x22, 0x1C,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xAA of the Courier */
	 0x00, 0x00, 0x18, 0x04, 0x1C, 0x24, 0x1C, 0x00, 0x3C, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xAB of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x22, 0x44, 0x22,  
	 0x11, 0x00, 0x00,  
	 /* The character 0xAC of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x02, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xAD of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xAE of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x59, 0x55, 0x59, 0x55, 0x22, 0x1C,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xAF of the Courier */
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB0 of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB1 of the Courier */
	 0x00, 0x00, 0x08, 0x08, 0x08, 0x7F, 0x08, 0x08, 0x08, 0x00,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0xB2 of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x04, 0x08, 0x1C, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB3 of the Courier */
	 0x00, 0x00, 0x18, 0x04, 0x08, 0x04, 0x18, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB4 of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB5 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x3C, 0x20, 0x40,  
	 /* The character 0xB6 of the Courier */
	 0x00, 0x00, 0x3F, 0x7A, 0x7A, 0x7A, 0x3A, 0x0A, 0x0A, 0x0A,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0xB7 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xB8 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
	 0x08, 0x04, 0x18,  
	 /* The character 0xB9 of the Courier */
	 0x00, 0x00, 0x18, 0x08, 0x08, 0x08, 0x1C, 0x00, 0x00, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xBA of the Courier */
	 0x00, 0x00, 0x18, 0x24, 0x24, 0x24, 0x18, 0x00, 0x3C, 0x00,  
	 0x00, 0x00, 0x00,  
	 /* The character 0xBB of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44, 0x22, 0x11, 0x22,  
	 0x44, 0x00, 0x00,  
	 /* The character 0xBC of the Courier */
	 0x00, 0x00, 0x60, 0x21, 0x22, 0x24, 0x79, 0x13, 0x25, 0x4F,  
	 0x01, 0x00, 0x00,  
	 /* The character 0xBD of the Courier */
	 0x00, 0x00, 0x60, 0x21, 0x22, 0x24, 0x7A, 0x15, 0x21, 0x42,  
	 0x07, 0x00, 0x00,  
	 /* The character 0xBE of the Courier */
	 0x00, 0x00, 0x60, 0x11, 0x22, 0x14, 0x69, 0x13, 0x25, 0x4F,  
	 0x01, 0x00, 0x00,  
	 /* The character 0xBF of the Courier */
	 0x00, 0x00, 0x08, 0x00, 0x08, 0x08, 0x10, 0x20, 0x20, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xC0 of the Courier */
	 0x10, 0x08, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC1 of the Courier */
	 0x04, 0x08, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC2 of the Courier */
	 0x08, 0x14, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC3 of the Courier */
	 0x39, 0x4E, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC4 of the Courier */
	 0x22, 0x00, 0x18, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC5 of the Courier */
	 0x08, 0x14, 0x08, 0x08, 0x08, 0x14, 0x14, 0x22, 0x3E, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xC6 of the Courier */
	 0x00, 0x00, 0x3F, 0x19, 0x18, 0x2A, 0x2E, 0x2A, 0x78, 0x49,  
	 0x4F, 0x00, 0x00,  
	 /* The character 0xC7 of the Courier */
	 0x00, 0x00, 0x00, 0x1E, 0x21, 0x40, 0x40, 0x40, 0x40, 0x21,  
	 0x1E, 0x04, 0x0C,  
	 /* The character 0xC8 of the Courier */
	 0x10, 0x08, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0xC9 of the Courier */
	 0x04, 0x08, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0xCA of the Courier */
	 0x08, 0x14, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0xCB of the Courier */
	 0x22, 0x00, 0x7F, 0x21, 0x20, 0x24, 0x3C, 0x24, 0x20, 0x21,  
	 0x7F, 0x00, 0x00,  
	 /* The character 0xCC of the Courier */
	 0x10, 0x08, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xCD of the Courier */
	 0x04, 0x08, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xCE of the Courier */
	 0x08, 0x14, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xCF of the Courier */
	 0x22, 0x00, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xD0 of the Courier */
	 0x00, 0x00, 0x7C, 0x22, 0x21, 0x21, 0x79, 0x21, 0x21, 0x22,  
	 0x7C, 0x00, 0x00,  
	 /* The character 0xD1 of the Courier */
	 0x39, 0x4E, 0x67, 0x22, 0x32, 0x32, 0x2A, 0x26, 0x26, 0x22,  
	 0x72, 0x00, 0x00,  
	 /* The character 0xD2 of the Courier */
	 0x10, 0x08, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xD3 of the Courier */
	 0x04, 0x08, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xD4 of the Courier */
	 0x08, 0x14, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xD5 of the Courier */
	 0x39, 0x4E, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xD6 of the Courier */
	 0x22, 0x00, 0x1C, 0x22, 0x41, 0x41, 0x41, 0x41, 0x41, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xD7 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x41, 0x22, 0x14, 0x08, 0x14, 0x22,  
	 0x41, 0x00, 0x00,  
	 /* The character 0xD8 of the Courier */
	 0x00, 0x00, 0x1D, 0x22, 0x45, 0x45, 0x49, 0x51, 0x51, 0x22,  
	 0x5C, 0x00, 0x00,  
	 /* The character 0xD9 of the Courier */
	 0x10, 0x08, 0x77, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xDA of the Courier */
	 0x04, 0x08, 0x77, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xDB of the Courier */
	 0x08, 0x14, 0x77, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xDC of the Courier */
	 0x22, 0x00, 0x77, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xDD of the Courier */
	 0x04, 0x08, 0x77, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x08,  
	 0x1C, 0x00, 0x00,  
	 /* The character 0xDE of the Courier */
	 0x00, 0x00, 0x60, 0x20, 0x3E, 0x21, 0x21, 0x21, 0x3E, 0x20,  
	 0x70, 0x00, 0x00,  
	 /* The character 0xDF of the Courier */
	 0x00, 0x00, 0x1C, 0x22, 0x22, 0x22, 0x2E, 0x21, 0x21, 0x21,  
	 0x6E, 0x00, 0x00,  
	 /* The character 0xE0 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE1 of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE2 of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE3 of the Courier */
	 0x00, 0x00, 0x39, 0x4E, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE4 of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE5 of the Courier */
	 0x00, 0x08, 0x14, 0x08, 0x00, 0x3C, 0x02, 0x3E, 0x42, 0x42,  
	 0x3D, 0x00, 0x00,  
	 /* The character 0xE6 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x09, 0x3F, 0x48, 0x49,  
	 0x36, 0x00, 0x00,  
	 /* The character 0xE7 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x41, 0x40, 0x40, 0x41,  
	 0x3E, 0x04, 0x0C,  
	 /* The character 0xE8 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x3E, 0x41, 0x7F, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xE9 of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x3E, 0x41, 0x7F, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xEA of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x00, 0x3E, 0x41, 0x7F, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xEB of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x3E, 0x41, 0x7F, 0x40, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xEC of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x38, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xED of the Courier */
	 0x00, 0x00, 0x08, 0x10, 0x00, 0x38, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xEE of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x00, 0x38, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xEF of the Courier */
	 0x00, 0x00, 0x24, 0x00, 0x00, 0x38, 0x08, 0x08, 0x08, 0x08,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF0 of the Courier */
	 0x00, 0x00, 0x36, 0x08, 0x34, 0x02, 0x3E, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF1 of the Courier */
	 0x00, 0x00, 0x39, 0x4E, 0x00, 0x6C, 0x32, 0x22, 0x22, 0x22,  
	 0x77, 0x00, 0x00,  
	 /* The character 0xF2 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF3 of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF4 of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF5 of the Courier */
	 0x00, 0x00, 0x39, 0x4E, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF6 of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x3E, 0x41, 0x41, 0x41, 0x41,  
	 0x3E, 0x00, 0x00,  
	 /* The character 0xF7 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x7F, 0x00, 0x00,  
	 0x08, 0x00, 0x00,  
	 /* The character 0xF8 of the Courier */
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x43, 0x4D, 0x59, 0x61,  
	 0x7E, 0x00, 0x00,  
	 /* The character 0xF9 of the Courier */
	 0x00, 0x00, 0x10, 0x08, 0x00, 0x66, 0x22, 0x22, 0x22, 0x26,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0xFA of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x66, 0x22, 0x22, 0x22, 0x26,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0xFB of the Courier */
	 0x00, 0x00, 0x08, 0x14, 0x00, 0x66, 0x22, 0x22, 0x22, 0x26,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0xFC of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x66, 0x22, 0x22, 0x22, 0x26,  
	 0x1B, 0x00, 0x00,  
	 /* The character 0xFD of the Courier */
	 0x00, 0x00, 0x04, 0x08, 0x00, 0x77, 0x22, 0x22, 0x14, 0x14,  
	 0x08, 0x08, 0x30,  
	 /* The character 0xFE of the Courier */
	 0x00, 0x00, 0x60, 0x20, 0x20, 0x3E, 0x21, 0x21, 0x21, 0x21,  
	 0x3E, 0x20, 0x70,  
	 /* The character 0xFF of the Courier */
	 0x00, 0x00, 0x22, 0x00, 0x00, 0x77, 0x22, 0x22, 0x14, 0x14,  
	 0x08, 0x08, 0x30,  
	},
};/* End Struct SME_SRC_IMAGE_T */

/* Resource Manager API */

BOOL SmeGetTextString(unsigned long nRcId, unsigned char nLang, const SME_CHAR** pText)
{

	if (nLang >= SME_LANGUAGE_NUM ) return FALSE;
	if (nRcId * SME_LANGUAGE_NUM * sizeof(unsigned long)
		>= sizeof(RcDataImage.TextIdxTbl))
		return FALSE;
	*pText = &(RcDataImage.TextStrData[RcDataImage.TextIdxTbl[nRcId * SME_LANGUAGE_NUM + nLang]]);
	return TRUE;
}

BOOL SmeGetMenuData(unsigned long nRcId, unsigned short *pItemNum, const struct SME_MENU_DATA_T** pMenuData)
{

	if (RcDataImage.MenuIdxTbl[nRcId].nRcType != SME_RC_TYPE_MENU) return FALSE;
	*pItemNum = RcDataImage.MenuIdxTbl[nRcId].nItemNum;
	*pMenuData = &(RcDataImage.MenuData[RcDataImage.MenuIdxTbl[nRcId].nOffset]);
	return TRUE;
}

BOOL SmeGetBitmap (unsigned long nRcId, struct SME_BITMAP_DATA_T *pBitmapData)
{

	pBitmapData->nWidth = RcDataImage.BitmapIdxTbl[nRcId].nWidth;
	pBitmapData->nHeight = RcDataImage.BitmapIdxTbl[nRcId].nHeight;
	pBitmapData->nBitCountPerPixel = RcDataImage.BitmapIdxTbl[nRcId].nBitCountPerPixel;
	pBitmapData->pData = &(RcDataImage.BitmapData[RcDataImage.BitmapIdxTbl[nRcId].nOffset]);
	pBitmapData->nLength = RcDataImage.BitmapIdxTbl[nRcId].nLength;
	return TRUE;
}

BOOL SmeGetFontInfo (unsigned long nFontID, struct SME_FONT_INFO_T *pFontInfo)
{

	pFontInfo->nHeight = RcDataImage.FontIdxTbl[nFontID].nHeight;
	pFontInfo->nWidth = RcDataImage.FontIdxTbl[nFontID].nWidth;
	pFontInfo->nStartChar = RcDataImage.FontIdxTbl[nFontID].nStartChar;
	pFontInfo->nEndChar = RcDataImage.FontIdxTbl[nFontID].nEndChar;
	pFontInfo->pData = &(RcDataImage.FontData[RcDataImage.FontIdxTbl[nFontID].nOffset]);
	pFontInfo->nLength = RcDataImage.FontIdxTbl[nFontID].nLength;
	return TRUE;
}

BOOL SmeGetFontBitmap(unsigned long nFontID, unsigned short nChar, const unsigned char** pFontData,
					  unsigned long * pLength)
{

	unsigned short nFontWidth = RcDataImage.FontIdxTbl[nFontID].nWidth;
	unsigned short nFontHeight = RcDataImage.FontIdxTbl[nFontID].nHeight;
	unsigned short nStartChar = RcDataImage.FontIdxTbl[nFontID].nStartChar;
	unsigned short nEndChar = RcDataImage.FontIdxTbl[nFontID].nEndChar;
	unsigned long nCharSize;

	int k;
	unsigned short nCharNum;
	unsigned long nRowNum;
	if (nChar<nStartChar || nChar>nEndChar) return FALSE;

	nRowNum = nFontWidth/8;
	k = nFontWidth % 8;
	if(k!=0)
		nRowNum++;

	nCharSize = nRowNum*nFontHeight;
	*pLength = nCharSize;
	nCharNum = nChar-nStartChar;
	*pFontData = &(RcDataImage.FontData[RcDataImage.FontIdxTbl[nFontID].nOffset+nCharNum*nCharSize]);

	return TRUE;
}

